# @file
# 
# - Find MPICompiler
# This module looks for the MPI C/C++/F77/F90 compilers. 
# It will set the following variables:
#  MPI_CC = MPI C compiler
#  MPI_CXX = MPI C++ compiler
#  MPI_F77 = MPI Fortran77 compiler
#  MPI_F90 = MPI Fortran90 compiler
#
# @author Tobias Hilbrich
#

FIND_PROGRAM (MPI_CC 
    NAMES mpicc mpcc mpcc_r mpxlc mpxlc_r mpiicc 
    PATHS ${MPI_HOME}/bin ${MPICH_HOME}/bin ${OPENMPI_HOME}/bin 
    NO_SYSTEM_ENVIRONMENT_PATH)
#IF (NOT MPI_CC)
#    SET (MPI_CC ${CMAKE_C_COMPILER} CACHE FILEPATH "The MPI C compiler" FORCE)
#ENDIF (NOT MPI_CC)

FIND_PROGRAM (MPI_CXX 
    NAMES mpicxx mpcxx mpcxx_r mpxlcxx mpxlcxx_r mpiicxx
          mpic++ mpc++ mpc++_r mpxlc++ mpxlc++_r mpiic++
          mpiCC mpCC mpCC_r mpxlCC mpxlCC_r mpiiCC 
    PATHS ${MPI_HOME}/bin ${MPICH_HOME}/bin ${OPENMPI_HOME}/bin 
    NO_SYSTEM_ENVIRONMENT_PATH)
#IF (NOT MPI_CXX)
#    SET (MPI_CXX ${CMAKE_CXX_COMPILER} CACHE FILEPATH "The MPI C++ compiler" FORCE)
#ENDIF (NOT MPI_CXX)

FIND_PROGRAM (MPI_F77 
    NAMES mpif77 mpf77 mpf77_r mpxlf77 mpxlf77_r mpiif77
    PATHS ${MPI_HOME}/bin ${MPICH_HOME}/bin ${OPENMPI_HOME}/bin 
    NO_SYSTEM_ENVIRONMENT_PATH)
#IF (NOT MPI_F77)
#    SET (MPI_F77 ${CMAKE_Fortran_COMPILER} CACHE FILEPATH "The MPI Fortran77 compiler" FORCE)
#ENDIF (NOT MPI_F77)

FIND_PROGRAM (MPI_F90 
    NAMES mpif90 mpf90 mpf90_r mpxlf90 mpxlf90_r mpiif90
    PATHS ${MPI_HOME}/bin ${MPICH_HOME}/bin ${OPENMPI_HOME}/bin 
    NO_SYSTEM_ENVIRONMENT_PATH)
#IF (NOT MPI_F90)
#    SET (MPI_F90 ${CMAKE_Fortran_COMPILER} CACHE FILEPATH "The MPI Fortran90 compiler" FORCE)
#ENDIF (NOT MPI_F90)

SET (MPICompiler_FOUND TRUE)