/**
 *  datatype.c
 *
 *  This is erroneous MPI-Program!
 *
 *  It causes two errors:
 *          - Active non completed request at MPI_Finalize
 *          - Non freed datatype at MPI_Finalize
 *  
 *  It just calls 
 *          - MPI_Init
 *          - MPI_Comm_rank
 *          - MPI_Comm_size
 *          - MPI_Type_contiguous
 *          - MPI_Isend
 *          - MPI_Recv
 *          - MPI_Type_commit
 *          - MPI_Finalize
 *
 */

#include <stdio.h>
#include <mpi.h>

int main(int argc, char **argv)
{
    //Used variables
    int rank;
    int size;
    int sendBuf[2] = {123,456};
    int recvBuf[2];
    int MSG_TAG = 1;
    MPI_Status status;
    MPI_Request request;
    MPI_Datatype cont2Int;

    //Initialize MPI, get rank and size
    MPI_Init(&argc, &argv);
    MPI_Comm_rank(MPI_COMM_WORLD, &rank);
    MPI_Comm_size(MPI_COMM_WORLD, &size);
    
    //Print a hello
    printf("I am rank %d of %d processes.\n", rank, size);

    //Create a datatype
    MPI_Type_contiguous(2, MPI_INT, &cont2Int);
    MPI_Type_commit(&cont2Int);
        
    //Send to successor process and receive from predecessor process
    MPI_Isend(sendBuf, 1, cont2Int, (rank+1)%size, MSG_TAG ,MPI_COMM_WORLD,&request);
    MPI_Recv(recvBuf, 1, cont2Int, (rank+size-1)%size, MSG_TAG ,MPI_COMM_WORLD,&status);

    //Say a good-bye
    printf("Rank %d has finished.\n",rank);
    
    //Finalize MPI
    MPI_Finalize();

    return 0;
}
