/*
 * Copyright (c) 2002-2008 High Performance Computing Center Stuttgart,
 *                         University of Stuttgart.  All rights reserved.
 * Copyright (c) 2006-2008 The Center for Information Services and HPC
 *                         Technical University of Dresden.
 *                         All rights reserved.
 *
 * $COPYRIGHT$
 *
 * Additional copyrights may follow
 *
 * $HEADER$
 */
#define MPI_ABORT(COMM,ERR) MPI_SOURCEINFO_ABORT(COMM,__LINE__,__FILE__,ERR)
#define MPI_ADDRESS(LOCATION, ADDRESS,ERR) MPI_SOURCEINFO_ADDRESS(LOCATION, ADDRESS,__LINE__,__FILE__,ERR)
#define MPI_ALLGATHER(SENDBUF, SENDCOUNT, SENDTYPE, RECVBUF, RECVCOUNT, RECVTYPE, COMM,ERR) MPI_SOURCEINFO_ALLGATHER(SENDBUF, SENDCOUNT, SENDTYPE, RECVBUF, RECVCOUNT, RECVTYPE, COMM,__LINE__,__FILE__,ERR)
#define MPI_ALLGATHERV(SENDBUF, SENDCOUNT, SENDTYPE, RECVBUF, RECVCOUNTS, DISPLS, RECVTYPE, COMM,ERR) MPI_SOURCEINFO_ALLGATHERV(SENDBUF, SENDCOUNT, SENDTYPE, RECVBUF, RECVCOUNTS, DISPLS, RECVTYPE, COMM,__LINE__,__FILE__,ERR)   
#define MPI_ALLREDUCE(SENDBUF, RECVBUF, COUNT, DATATYPE, OP, COMM,ERR) MPI_SOURCEINFO_ALLREDUCE(SENDBUF, RECVBUF, COUNT, DATATYPE, OP, COMM,__LINE__,__FILE__,ERR)
#define MPI_ALLTOALL(SENDBUF, SENDCOUNT, SENDTYPE, RECVBUF, RECVCOUNT, RECVTYPE, COMM,ERR) MPI_SOURCEINFO_ALLTOALL(SENDBUF, SENDCOUNT, SENDTYPE, RECVBUF, RECVCOUNT, RECVTYPE, COMM,__LINE__,__FILE__,ERR)
#define MPI_ALLTOALLV(SENDBUF, SENDCOUNTS, SDISPLS, SENDTYPE, RECVBUF, RECVCOUNTS, RDISPLS, RECVTYPE, COMM,ERR) MPI_SOURCEINFO_ALLTOALLV(SENDBUF, SENDCOUNTS, SDISPLS, SENDTYPE, RECVBUF, RECVCOUNTS, RDISPLS, RECVTYPE, COMM,__LINE__,__FILE__,ERR)
#define MPI_ATTR_DELETE(COMM, KEYVAL,ERR) MPI_SOURCEINFO_ATTR_DELETE(COMM, KEYVAL,__LINE__,__FILE__,ERR)
#define MPI_ATTR_GET(COMM, KEYVAL, ATTRIBUTE_VAL, FLAG,ERR) MPI_SOURCEINFO_ATTR_GET(COMM, KEYVAL, ATTRIBUTE_VAL, FLAG,__LINE__,__FILE__,ERR)
#define MPI_ATTR_PUT(COMM, KEYVAL, ATTRIBUTE_VAL,ERR) MPI_SOURCEINFO_ATTR_PUT(COMM, KEYVAL, ATTRIBUTE_VAL,__LINE__,__FILE__,ERR)
#define MPI_BARRIER(COMM ,ERR) MPI_SOURCEINFO_BARRIER(COMM ,__LINE__,__FILE__,ERR)
#define MPI_BCAST(BUFFER, COUNT, DATATYPE, ROOT, COMM ,ERR) MPI_SOURCEINFO_BCAST(BUFFER, COUNT, DATATYPE, ROOT, COMM ,__LINE__,__FILE__,ERR)
#define MPI_BSEND(BUF, COUNT, DATATYPE, DEST, TAG, COMM,ERR) MPI_SOURCEINFO_BSEND(BUF, COUNT, DATATYPE, DEST, TAG, COMM,__LINE__,__FILE__,ERR)
#define MPI_BSEND_INIT(BUF, COUNT, DATATYPE, DEST, TAG, COMM, REQUEST,ERR) MPI_SOURCEINFO_BSEND_INIT(BUF, COUNT, DATATYPE, DEST, TAG, COMM, REQUEST,__LINE__,__FILE__,ERR)
#define MPI_BUFFER_ATTACH( BUFFER, SIZE,ERR) MPI_SOURCEINFO_BUFFER_ATTACH( BUFFER, SIZE,__LINE__,__FILE__,ERR)
#define MPI_BUFFER_DETACH( BUFFER, SIZE,ERR) MPI_SOURCEINFO_BUFFER_DETACH( BUFFER, SIZE,__LINE__,__FILE__,ERR)
#define MPI_CANCEL(REQUEST,ERR) MPI_SOURCEINFO_CANCEL(REQUEST,__LINE__,__FILE__,ERR)
#define MPI_CART_COORDS(COMM, RANK, MAXDIMS, COORDS,ERR) MPI_SOURCEINFO_CART_COORDS(COMM, RANK, MAXDIMS, COORDS,__LINE__,__FILE__,ERR)
#define MPI_CART_CREATE(COMM_OLD, NDIMS, DIMS, PERIODS, REORDER, COMM_CART,ERR) MPI_SOURCEINFO_CART_CREATE(COMM_OLD, NDIMS, DIMS, PERIODS, REORDER, COMM_CART,__LINE__,__FILE__,ERR)
#define MPI_CART_GET(COMM, MAXDIMS, DIMS, PERIODS, COORDS,ERR) MPI_SOURCEINFO_CART_GET(COMM, MAXDIMS, DIMS, PERIODS, COORDS,__LINE__,__FILE__,ERR)
#define MPI_CART_MAP(COMM, NDIMS, DIMS, PERIODS, NEWRANK,ERR) MPI_SOURCEINFO_CART_MAP(COMM, NDIMS, DIMS, PERIODS, NEWRANK,__LINE__,__FILE__,ERR)
#define MPI_CART_RANK(COMM, COORDS, RANK,ERR) MPI_SOURCEINFO_CART_RANK(COMM, COORDS, RANK,__LINE__,__FILE__,ERR)
#define MPI_CART_SHIFT(COMM, DIRECTION, DISP, RANK_SOURCE, RANK_DEST,ERR) MPI_SOURCEINFO_CART_SHIFT(COMM, DIRECTION, DISP, RANK_SOURCE, RANK_DEST,__LINE__,__FILE__,ERR)
#define MPI_CART_SUB(COMM, REMAIN_DIMS, NEWCOMM,ERR) MPI_SOURCEINFO_CART_SUB(COMM, REMAIN_DIMS, NEWCOMM,__LINE__,__FILE__,ERR)
#define MPI_CARTDIM_GET(COMM, NDIMS,ERR) MPI_SOURCEINFO_CARTDIM_GET(COMM, NDIMS,__LINE__,__FILE__,ERR)
#define MPI_COMM_COMPARE(COMM1,COMM2,RESULT,ERR) MPI_SOURCEINFO_COMM_COMPARE(COMM1,COMM2,RESULT,__LINE__,__FILE__,ERR)
#define MPI_COMM_CREATE(COMM,GROUP,NEWCOMM,ERR) MPI_SOURCEINFO_COMM_CREATE(COMM,GROUP,NEWCOMM,__LINE__,__FILE__,ERR)
#define MPI_COMM_DUP(COMM,NEWCOMM,ERR) MPI_SOURCEINFO_COMM_DUP(COMM,NEWCOMM,__LINE__,__FILE__,ERR)
#define MPI_COMM_FREE(COMM,ERR) MPI_SOURCEINFO_COMM_FREE(COMM,__LINE__,__FILE__,ERR)
#define MPI_COMM_GROUP(COMM,GROUP,ERR) MPI_SOURCEINFO_COMM_GROUP(COMM,GROUP,__LINE__,__FILE__,ERR)
#define MPI_COMM_RANK(COMM, RANK,ERR) MPI_SOURCEINFO_COMM_RANK(COMM, RANK,__LINE__,__FILE__,ERR)
#define MPI_COMM_REMOTE_GROUP(COMM, GROUP,ERR) MPI_SOURCEINFO_COMM_REMOTE_GROUP(COMM, GROUP,__LINE__,__FILE__,ERR)
#define MPI_COMM_REMOTE_SIZE(COMM, SIZE,ERR) MPI_SOURCEINFO_COMM_REMOTE_SIZE(COMM, SIZE,__LINE__,__FILE__,ERR)
#define MPI_COMM_SIZE(COMM, SIZE,ERR) MPI_SOURCEINFO_COMM_SIZE(COMM, SIZE,__LINE__,__FILE__,ERR)
#define MPI_COMM_SPLIT(COMM, COLOR, KEY, NEWCOMM,ERR) MPI_SOURCEINFO_COMM_SPLIT(COMM, COLOR, KEY, NEWCOMM,__LINE__,__FILE__,ERR)
#define MPI_COMM_TEST_INTER(COMM, FLAG,ERR) MPI_SOURCEINFO_COMM_TEST_INTER(COMM, FLAG,__LINE__,__FILE__,ERR)
#define MPI_DIMS_CREATE(NNODES,NDIMS,DIMS,ERR) MPI_SOURCEINFO_DIMS_CREATE(NNODES,NDIMS,DIMS,__LINE__,__FILE__,ERR)
#define MPI_ERRHANDLER_CREATE(FUNCTION,ERRHANDLER,ERR) MPI_SOURCEINFO_ERRHANDLER_CREATE(FUNCTION,ERRHANDLER,__LINE__,__FILE__,ERR)
#define MPI_ERRHANDLER_FREE(ERRHANDLER,ERR) MPI_SOURCEINFO_ERRHANDLER_FREE(ERRHANDLER,__LINE__,__FILE__,ERR)
#define MPI_ERRHANDLER_GET(COMM,ERRHANDLER,ERR) MPI_SOURCEINFO_ERRHANDLER_GET(COMM,ERRHANDLER,__LINE__,__FILE__,ERR)
#define MPI_ERRHANDLER_SET(COMM,ERRHANDLER,ERR) MPI_SOURCEINFO_ERRHANDLER_SET(COMM,ERRHANDLER,__LINE__,__FILE__,ERR)
#define MPI_ERROR_CLASS(ERRORCODE,ERRORCLASS,ERR) MPI_SOURCEINFO_ERROR_CLASS(ERRORCODE,ERRORCLASS,__LINE__,__FILE__,ERR)
#define MPI_ERROR_STRING(ERRORCODE,STRING,RESULTLEN,ERR) MPI_SOURCEINFO_ERROR_STRING(ERRORCODE,STRING,RESULTLEN,__LINE__,__FILE__,ERR)
#define MPI_FINALIZE(ERR) MPI_SOURCEINFO_FINALIZE(__LINE__,__FILE__,ERR)
#define MPI_GATHER(SENDBUF,SENDCOUNT,SENDTYPE,RECVBUF,RECVCOUNT,RECVTYPE,ROOT,COMM,ERR) MPI_SOURCEINFO_GATHER(SENDBUF,SENDCOUNT,SENDTYPE,RECVBUF,RECVCOUNT,RECVTYPE,ROOT,COMM,__LINE__,__FILE__,ERR)
#define MPI_GATHERV(SENDBUF,SENDCOUNT,SENDTYPE,RECVBUF,RECVCOUNTS,DISPLS,RECVTYPE,ROOT,COMM,ERR) MPI_SOURCEINFO_GATHERV(SENDBUF,SENDCOUNT,SENDTYPE,RECVBUF,RECVCOUNTS,DISPLS,RECVTYPE,ROOT,COMM,__LINE__,__FILE__,ERR)
#define MPI_GET_COUNT(STATUS,DATATYPE,COUNT,ERR) MPI_SOURCEINFO_GET_COUNT(STATUS,DATATYPE,COUNT,__LINE__,__FILE__,ERR)
#define MPI_GET_ELEMENTS(STATUS,DATATYPE,COUNT,ERR) MPI_SOURCEINFO_GET_ELEMENTS(STATUS,DATATYPE,COUNT,__LINE__,__FILE__,ERR)
#define MPI_GET_PROCESSOR_NAME(NAME,RESULTLEN,ERR) MPI_SOURCEINFO_GET_PROCESSOR_NAME(NAME,RESULTLEN,__LINE__,__FILE__,ERR)
#define MPI_GET_VERSION(VERSION,SUBVERSION,ERR) MPI_SOURCEINFO_GET_VERSION(VERSION,SUBVERSION,__LINE__,__FILE__,ERR)
#define MPI_GRAPH_CREATE(COMM_OLD,NNODES,INDEX,EDGES,REORDER,COMM_GRAPH,ERR) MPI_SOURCEINFO_GRAPH_CREATE(COMM_OLD,NNODES,INDEX,EDGES,REORDER,COMM_GRAPH,__LINE__,__FILE__,ERR)
#define MPI_GRAPH_GET(COMM,MAXINDEX,MAXEDGES,INDEX,EDGES,ERR) MPI_SOURCEINFO_GRAPH_GET(COMM,MAXINDEX,MAXEDGES,INDEX,EDGES,__LINE__,__FILE__,ERR)
#define MPI_GRAPH_MAP(COMM,NNODES,INDEX,EDGES,NEWRANK,ERR) MPI_SOURCEINFO_GRAPH_MAP(COMM,NNODES,INDEX,EDGES,NEWRANK,__LINE__,__FILE__,ERR)
#define MPI_GRAPH_NEIGHBORS(COMM,RANK,MAXNEIGHBORS,NEIGHBORS,ERR) MPI_SOURCEINFO_GRAPH_NEIGHBORS(COMM,RANK,MAXNEIGHBORS,NEIGHBORS,__LINE__,__FILE__,ERR)
#define MPI_GRAPH_NEIGHBORS_COUNT(COMM,RANK,NNEIGHBORS,ERR) MPI_SOURCEINFO_GRAPH_NEIGHBORS_COUNT(COMM,RANK,NNEIGHBORS,__LINE__,__FILE__,ERR)
#define MPI_GRAPHDIMS_GET(COMM,NNODES,NEDGES,ERR) MPI_SOURCEINFO_GRAPHDIMS_GET(COMM,NNODES,NEDGES,__LINE__,__FILE__,ERR)
#define MPI_GROUP_COMPARE(GROUP1,GROUP2,RESULT,ERR) MPI_SOURCEINFO_GROUP_COMPARE(GROUP1,GROUP2,RESULT,__LINE__,__FILE__,ERR)
#define MPI_GROUP_DIFFERENCE(GROUP1,GROUP2,NEWGROUP,ERR) MPI_SOURCEINFO_GROUP_DIFFERENCE(GROUP1,GROUP2,NEWGROUP,__LINE__,__FILE__,ERR)
#define MPI_GROUP_EXCL(GROUP,N,RANKS,NEWGROUP,ERR) MPI_SOURCEINFO_GROUP_EXCL(GROUP,N,RANKS,NEWGROUP,__LINE__,__FILE__,ERR)
#define MPI_GROUP_FREE(GROUP,ERR) MPI_SOURCEINFO_GROUP_FREE(GROUP,__LINE__,__FILE__,ERR)
#define MPI_GROUP_INCL(GROUP,N,RANKS,NEWGROUP,ERR) MPI_SOURCEINFO_GROUP_INCL(GROUP,N,RANKS,NEWGROUP,__LINE__,__FILE__,ERR)
#define MPI_GROUP_INTERSECTION(GROUP1,GROUP2,NEWGROUP,ERR) MPI_SOURCEINFO_GROUP_INTERSECTION(GROUP1,GROUP2,NEWGROUP,__LINE__,__FILE__,ERR)
#define MPI_GROUP_RANK(GROUP,RANK,ERR) MPI_SOURCEINFO_GROUP_RANK(GROUP,RANK,__LINE__,__FILE__,ERR)
#define MPI_GROUP_SIZE(GROUP,SIZE,ERR) MPI_SOURCEINFO_GROUP_SIZE(GROUP,SIZE,__LINE__,__FILE__,ERR)
#define MPI_GROUP_TRANSLATE_RANKS(GROUP1,N,RANKS1,GROUP2,RANKS2,ERR) MPI_SOURCEINFO_GROUP_TRANSLATE_RANKS(GROUP1,N,RANKS1,GROUP2,RANKS2,__LINE__,__FILE__,ERR)
#define MPI_GROUP_UNION(GROUP1,GROUP2,NEWGROUP,ERR) MPI_SOURCEINFO_GROUP_UNION(GROUP1,GROUP2,NEWGROUP,__LINE__,__FILE__,ERR)
#define MPI_IBSEND(BUF,COUNT,DATATYPE,DEST,TAG,COMM,REQUEST,ERR) MPI_SOURCEINFO_IBSEND(BUF,COUNT,DATATYPE,DEST,TAG,COMM,REQUEST,__LINE__,__FILE__,ERR)
#define MPI_INIT(ERR) MPI_SOURCEINFO_INIT(__LINE__,__FILE__,ERR)
#define MPI_INITIALIZED(FLAG,ERR) MPI_SOURCEINFO_INITIALIZED(FLAG,__LINE__,__FILE__,ERR)
#define MPI_INTERCOMM_CREATE(LOCAL_COMM,LOCAL_LEADER,PEER_COMM,REMOTE_LEADER,TAG,NEWINTERCOMM,ERR) MPI_SOURCEINFO_INTERCOMM_CREATE(LOCAL_COMM,LOCAL_LEADER,PEER_COMM,REMOTE_LEADER,TAG,NEWINTERCOMM,__LINE__,__FILE__,ERR)
#define MPI_INTERCOMM_MERGE(INTERCOMM,HIGH,NEWINTRACOMM,ERR) MPI_SOURCEINFO_INTERCOMM_MERGE(INTERCOMM,HIGH,NEWINTRACOMM,__LINE__,__FILE__,ERR)
#define MPI_IPROBE(SOURCE,TAG,COMM,FLAG,STATUS,ERR) MPI_SOURCEINFO_IPROBE(SOURCE,TAG,COMM,FLAG,STATUS,__LINE__,__FILE__,ERR)
#define MPI_IRECV(BUF,COUNT,DATATYPE,SOURCE,TAG,COMM,REQUEST,ERR) MPI_SOURCEINFO_IRECV(BUF,COUNT,DATATYPE,SOURCE,TAG,COMM,REQUEST,__LINE__,__FILE__,ERR)
#define MPI_IRSEND(BUF, COUNT, DATATYPE, DEST, TAG, COMM, REQUEST,ERR) MPI_SOURCEINFO_IRSEND(BUF, COUNT, DATATYPE, DEST, TAG, COMM, REQUEST,__LINE__,__FILE__,ERR)
#define MPI_ISEND(BUF, COUNT, DATATYPE, DEST, TAG, COMM, REQUEST,ERR) MPI_SOURCEINFO_ISEND(BUF, COUNT, DATATYPE, DEST, TAG, COMM, REQUEST,__LINE__,__FILE__,ERR)
#define MPI_ISSEND(BUF, COUNT,  DATATYPE, DEST, TAG, COMM, REQUEST,ERR) MPI_SOURCEINFO_ISSEND(BUF, COUNT,  DATATYPE, DEST, TAG, COMM, REQUEST,__LINE__,__FILE__,ERR)
#define MPI_KEYVAL_CREATE(COPY_FN, DELETE_FN, KEYVAL, EXTRA_STATE,ERR) MPI_SOURCEINFO_KEYVAL_CREATE(COPY_FN, DELETE_FN, KEYVAL, EXTRA_STATE,__LINE__,__FILE__,ERR)
#define MPI_KEYVAL_FREE(KEYVAL,ERR) MPI_SOURCEINFO_KEYVAL_FREE(KEYVAL,__LINE__,__FILE__,ERR)
#define MPI_OP_CREATE(FUNCTION, COMMUTE, OP,ERR) MPI_SOURCEINFO_OP_CREATE(FUNCTION, COMMUTE, OP,__LINE__,__FILE__,ERR)
#define MPI_OP_FREE( OP,ERR) MPI_SOURCEINFO_OP_FREE( OP,__LINE__,__FILE__,ERR)
#define MPI_PACK(INBUF, INCOUNT, DATATYPE, OUTBUF, OUTSIZE, POSITION, COMM,ERR) MPI_SOURCEINFO_PACK(INBUF, INCOUNT, DATATYPE, OUTBUF, OUTSIZE, POSITION, COMM,__LINE__,__FILE__,ERR)
#define MPI_PACK_SIZE(INCOUNT,DATATYPE,COMM,SIZE,ERR) MPI_SOURCEINFO_PACK_SIZE(INCOUNT,DATATYPE,COMM,SIZE,__LINE__,__FILE__,ERR)
#define MPI_PCONTROL(LEVEL, OTHERS,ERR) MPI_SOURCEINFO_PCONTROL(LEVEL,__LINE__,__FILE__, OTHERS,ERR)
#define MPI_PROBE(SOURCE,TAG,COMM, STATUS,ERR) MPI_SOURCEINFO_PROBE(SOURCE,TAG,COMM, STATUS,__LINE__,__FILE__,ERR)
#define MPI_RECV(BUF,COUNT,DATATYPE,SOURCE,TAG,COMM,STATUS,ERR) MPI_SOURCEINFO_RECV(BUF,COUNT,DATATYPE,SOURCE,TAG,COMM,STATUS,__LINE__,__FILE__,ERR)
#define MPI_RECV_INIT(BUF,COUNT,DATATYPE,SOURCE,TAG, COMM,REQUEST,ERR) MPI_SOURCEINFO_RECV_INIT(BUF,COUNT,DATATYPE,SOURCE,TAG, COMM,REQUEST,__LINE__,__FILE__,ERR)   
#define MPI_REDUCE(SENDBUF,RECVBUF,COUNT,DATATYPE, OP,ROOT,COMM,ERR) MPI_SOURCEINFO_REDUCE(SENDBUF,RECVBUF,COUNT,DATATYPE, OP,ROOT,COMM,__LINE__,__FILE__,ERR)
#define MPI_REDUCE_SCATTER(SENDBUF,RECVBUF,RECVCOUNTS,DATATYPE,OP,COMM,ERR) MPI_SOURCEINFO_REDUCE_SCATTER(SENDBUF,RECVBUF,RECVCOUNTS,DATATYPE,OP,COMM,__LINE__,__FILE__,ERR)
#define MPI_REQUEST_FREE(REQUEST,ERR) MPI_SOURCEINFO_REQUEST_FREE(REQUEST,__LINE__,__FILE__,ERR)
#define MPI_RSEND(BUF,COUNT, DATATYPE,DEST,TAG,COMM,ERR) MPI_SOURCEINFO_RSEND(BUF,COUNT, DATATYPE,DEST,TAG,COMM,__LINE__,__FILE__,ERR)   
#define MPI_RSEND_INIT(BUF,COUNT,DATATYPE,DEST,TAG, COMM,REQUEST,ERR) MPI_SOURCEINFO_RSEND_INIT(BUF,COUNT,DATATYPE,DEST,TAG, COMM,REQUEST,__LINE__,__FILE__,ERR)
#define MPI_SCAN(SENDBUF,RECVBUF,COUNT, DATATYPE, OP, COMM ,ERR) MPI_SOURCEINFO_SCAN(SENDBUF,RECVBUF,COUNT, DATATYPE, OP, COMM ,__LINE__,__FILE__,ERR)
#define MPI_SCATTER(SENDBUF, SENDCOUNT, SENDTYPE, RECVBUF, RECVCOUNT, RECVTYPE, ROOT, COMM,ERR) MPI_SOURCEINFO_SCATTER(SENDBUF, SENDCOUNT, SENDTYPE, RECVBUF, RECVCOUNT, RECVTYPE, ROOT, COMM,__LINE__,__FILE__,ERR)
#define MPI_SCATTERV(SENDBUF,SENDCOUNTS,DISPLS, SENDTYPE, RECVBUF, RECVCOUNT, RECVTYPE, ROOT, COMM,ERR) MPI_SOURCEINFO_SCATTERV(SENDBUF,SENDCOUNTS,DISPLS, SENDTYPE, RECVBUF, RECVCOUNT, RECVTYPE, ROOT, COMM,__LINE__,__FILE__,ERR)
#define MPI_SEND(BUF, COUNT,DATATYPE, DEST, TAG, COMM,ERR) MPI_SOURCEINFO_SEND(BUF, COUNT,DATATYPE, DEST, TAG, COMM,__LINE__,__FILE__,ERR) 
#define MPI_SEND_INIT(BUF, COUNT, DATATYPE, DEST, TAG, COMM, REQUEST,ERR) MPI_SOURCEINFO_SEND_INIT(BUF, COUNT, DATATYPE, DEST, TAG, COMM, REQUEST,__LINE__,__FILE__,ERR)
#define MPI_SENDRECV(SENDBUF, SENDCOUNT, SENDTYPE, DEST, SENDTAG, RECVBUF, RECVCOUNT, RECVTYPE, SOURCE, RECVTAG, COMM, STATUS,ERR) MPI_SOURCEINFO_SENDRECV(SENDBUF, SENDCOUNT, SENDTYPE, DEST, SENDTAG, RECVBUF, RECVCOUNT, RECVTYPE, SOURCE, RECVTAG, COMM, STATUS,__LINE__,__FILE__,ERR)
#define MPI_SENDRECV_REPLACE(BUF,COUNT, DATATYPE, DEST, SENDTAG, SOURCE, RECVTAG, COMM, STATUS,ERR) MPI_SOURCEINFO_SENDRECV_REPLACE(BUF,COUNT, DATATYPE, DEST, SENDTAG, SOURCE, RECVTAG, COMM, STATUS,__LINE__,__FILE__,ERR)
#define MPI_SSEND(BUF, COUNT, DATATYPE, DEST, TAG, COMM,ERR) MPI_SOURCEINFO_SSEND(BUF, COUNT, DATATYPE, DEST, TAG, COMM,__LINE__,__FILE__,ERR)
#define MPI_SSEND_INIT(BUF,COUNT,DATATYPE,DEST,TAG,COMM,REQUEST,ERR) MPI_SOURCEINFO_SSEND_INIT(BUF,COUNT,DATATYPE,DEST,TAG,COMM,REQUEST,__LINE__,__FILE__,ERR)
#define MPI_START(REQUEST,ERR) MPI_SOURCEINFO_START(REQUEST,__LINE__,__FILE__,ERR)
#define MPI_STARTALL(COUNT,ARRAY_OF_REQUESTS,ERR) MPI_SOURCEINFO_STARTALL(COUNT,ARRAY_OF_REQUESTS,__LINE__,__FILE__,ERR)
#define MPI_TEST(REQUEST, FLAG, STATUS,ERR) MPI_SOURCEINFO_TEST(REQUEST, FLAG, STATUS,__LINE__,__FILE__,ERR)
#define MPI_TEST_CANCELLED(STATUS, FLAG,ERR) MPI_SOURCEINFO_TEST_CANCELLED(STATUS, FLAG,__LINE__,__FILE__,ERR)
#define MPI_TESTALL(COUNT, ARRAY_OF_REQUESTS, FLAG, ARRAY_OF_STATUSES,ERR) MPI_SOURCEINFO_TESTALL(COUNT, ARRAY_OF_REQUESTS, FLAG, ARRAY_OF_STATUSES,__LINE__,__FILE__,ERR)
#define MPI_TESTANY(COUNT, ARRAY_OF_REQUESTS, INDEX, FLAG, STATUS,ERR) MPI_SOURCEINFO_TESTANY(COUNT, ARRAY_OF_REQUESTS, INDEX, FLAG, STATUS,__LINE__,__FILE__,ERR)
#define MPI_TESTSOME(INCOUNT, ARRAY_OF_REQUESTS, OUTCOUNT, ARRAY_OF_INDICES, ARRAY_OF_STATUSES,ERR) MPI_SOURCEINFO_TESTSOME(INCOUNT, ARRAY_OF_REQUESTS, OUTCOUNT, ARRAY_OF_INDICES, ARRAY_OF_STATUSES,__LINE__,__FILE__,ERR)
#define MPI_TOPO_TEST(COMM, STATUS,ERR) MPI_SOURCEINFO_TOPO_TEST(COMM, STATUS,__LINE__,__FILE__,ERR)
#define MPI_TYPE_COMMIT(DATATYPE,ERR) MPI_SOURCEINFO_TYPE_COMMIT(DATATYPE,__LINE__,__FILE__,ERR)
#define MPI_TYPE_CONTIGUOUS(COUNT,OLDTYPE,NEWTYPE,ERR) MPI_SOURCEINFO_TYPE_CONTIGUOUS(COUNT,OLDTYPE,NEWTYPE,__LINE__,__FILE__,ERR) 
#define MPI_TYPE_EXTENT(DATATYPE,EXTENT,ERR) MPI_SOURCEINFO_TYPE_EXTENT(DATATYPE,EXTENT,__LINE__,__FILE__,ERR)
#define MPI_TYPE_FREE(DATATYPE,ERR) MPI_SOURCEINFO_TYPE_FREE(DATATYPE,__LINE__,__FILE__,ERR)
#define MPI_TYPE_HINDEXED(COUNT, ARRAY_OF_BLOCKLENGTHS, ARRAY_OF_DISPLACEMENTS, OLDTYPE, NEWTYPE,ERR) MPI_SOURCEINFO_TYPE_HINDEXED(COUNT, ARRAY_OF_BLOCKLENGTHS, ARRAY_OF_DISPLACEMENTS, OLDTYPE, NEWTYPE,__LINE__,__FILE__,ERR)
#define MPI_TYPE_HVECTOR(COUNT, BLOCKLENGTH, STRIDE, OLDTYPE, NEWTYPE,ERR) MPI_SOURCEINFO_TYPE_HVECTOR(COUNT, BLOCKLENGTH, STRIDE, OLDTYPE, NEWTYPE,__LINE__,__FILE__,ERR)
#define MPI_TYPE_INDEXED(COUNT, ARRAY_OF_BLOCKLENGTHS, ARRAY_OF_DISPLACEMENTS, OLDTYPE, NEWTYPE,ERR) MPI_SOURCEINFO_TYPE_INDEXED(COUNT, ARRAY_OF_BLOCKLENGTHS, ARRAY_OF_DISPLACEMENTS, OLDTYPE, NEWTYPE,__LINE__,__FILE__,ERR)
#define MPI_TYPE_LB(DATATYPE, DISPLACEMENT,ERR) MPI_SOURCEINFO_TYPE_LB(DATATYPE, DISPLACEMENT,__LINE__,__FILE__,ERR)
#define MPI_TYPE_SIZE(DATATYPE,SIZE,ERR) MPI_SOURCEINFO_TYPE_SIZE(DATATYPE,SIZE,__LINE__,__FILE__,ERR)
#define MPI_TYPE_STRUCT(COUNT, ARRAY_OF_BLOCKLENGTHS,ARRAY_OF_DISPLACEMENTS, ARRAY_OF_TYPES, NEWTYPE,ERR) MPI_SOURCEINFO_TYPE_STRUCT(COUNT, ARRAY_OF_BLOCKLENGTHS,ARRAY_OF_DISPLACEMENTS, ARRAY_OF_TYPES, NEWTYPE,__LINE__,__FILE__,ERR)
#define MPI_TYPE_UB(DATATYPE,DISPLACEMENT,ERR) MPI_SOURCEINFO_TYPE_UB(DATATYPE,DISPLACEMENT,__LINE__,__FILE__,ERR)
#define MPI_TYPE_VECTOR(COUNT, BLOCKLENGTH, STRIDE, OLDTYPE, NEWTYPE,ERR) MPI_SOURCEINFO_TYPE_VECTOR(COUNT, BLOCKLENGTH, STRIDE, OLDTYPE, NEWTYPE,__LINE__,__FILE__,ERR)
#define MPI_UNPACK(INBUF, INSIZE, POSITION, OUTBUF, OUTCOUNT, DATATYPE,COMM,ERR) MPI_SOURCEINFO_UNPACK(INBUF, INSIZE, POSITION, OUTBUF, OUTCOUNT, DATATYPE,COMM,__LINE__,__FILE__,ERR)
#define MPI_WAIT(REQUEST, STATUS,ERR) MPI_SOURCEINFO_WAIT(REQUEST, STATUS,__LINE__,__FILE__,ERR)
#define MPI_WAITALL(COUNT, ARRAY_OF_REQUESTS, ARRAY_OF_STATUSES,ERR) MPI_SOURCEINFO_WAITALL(COUNT, ARRAY_OF_REQUESTS, ARRAY_OF_STATUSES,__LINE__,__FILE__,ERR)   
#define MPI_WAITANY(COUNT, ARRAY_OF_REQUESTS, INDEX, STATUS,ERR) MPI_SOURCEINFO_WAITANY(COUNT, ARRAY_OF_REQUESTS, INDEX, STATUS,__LINE__,__FILE__,ERR)
#define MPI_WAITSOME(INCOUNT,ARRAY_OF_REQUESTS, OUTCOUNT,ARRAY_OF_INDICES, ARRAY_OF_STATUSES,ERR) MPI_SOURCEINFO_WAITSOME(INCOUNT,ARRAY_OF_REQUESTS, OUTCOUNT,ARRAY_OF_INDICES, ARRAY_OF_STATUSES,__LINE__,__FILE__,ERR)
