/*
 * Copyright (c) 2002-2008 High Performance Computing Center Stuttgart,
 *                         University of Stuttgart.  All rights reserved.
 * Copyright (c) 2006-2008 The Center for Information Services and HPC
 *                         Technical University of Dresden.
 *                         All rights reserved.
 *
 * $COPYRIGHT$
 *
 * Additional copyrights may follow
 *
 * $HEADER$
 */
/**
 *  @file
 *
 *  Definition of the base class MPO_Typeobject.
 *
 *  This base class represents MPI types.
 * 
 *  @author Bettina Krammer
 *
 *  $Id: MPO_Typeobject.cc 838 2008-06-13 10:44:34Z hpchimml $
 */


#include "mpo.h"
#include "mpo-objects.h"
#include "mpo-binaryIO.h"
#include "mpo-debugserver.h"
#include "mpo-messenger.h"
#include "mpo-autogenerated.h"


namespace MPO
{

    // default constructor
    //========================================================================
    MPO_Typeobject::MPO_Typeobject()
    {
    }


    // destructor
    //========================================================================
    MPO_Typeobject::~MPO_Typeobject()
    {
    }


    // getFamilyId
    //========================================================================
    int MPO_Typeobject::getFamilyId() const
    {
        // returns the unique family identity set by enum MPO_FAMILY_ID
        return MPO_TYPEOBJECT_ID;
    }


}                               // end of namespace MPO
