/*
 * Copyright (c) 2002-2008 High Performance Computing Center Stuttgart,
 *                         University of Stuttgart.  All rights reserved.
 * Copyright (c) 2006-2008 The Center for Information Services and HPC
 *                         Technical University of Dresden.
 *                         All rights reserved.
 *
 * $COPYRIGHT$
 *
 * Additional copyrights may follow
 *
 * $HEADER$
 */
#pragma once

#include <string>
#include <vector>

class IToolWinComm;

#ifdef EXPORTING_DLL
#define DLL_EXP __declspec(dllexport)
#else
#define DLL_EXP __declspec(dllimport)
#endif

/**
 * This interface is used to communicate with the AddIn.
 * This header must not include any MFC/COM/OLE headers as
 * otherwise the addin that includes this header will get 
 * into trouble ...
 *
 */
class DLL_EXP IAddinComm
{
protected:
	IToolWinComm* m_pToolWinComm;	

public:
	IAddinComm(void);
	~IAddinComm(void);

	//Incomming Querys
	void setToolWinComm (IToolWinComm *pToolWinComm);
	virtual void popNewMarmotMsg (std::vector<std::string> messageparts) = 0;
	virtual void popClear (void) = 0;
	
	//Outgoing Querys
	virtual void pushOpenSourceFileLocation (std::string filename, int line) = 0;
	virtual void pushOpenHTMLFile (std::string filename) = 0;
};

/**
 * We use this silly global function to get a pointer to
 * an IAddinComm implementation. In theory the addin should
 * be able to use the returned window when calling 
 * CreateToolWindow to get an object in the DICE dll. 
 * But I never got this working ... so I avoided that and
 * implemented this function.
 */
extern DLL_EXP IAddinComm* getToolWinObject (void);

#undef EXPORTING_DLL
#define USE_MARMOT_DICE
#include "IToolWinComm.h"