/*
 * Copyright (c) 2002-2008 High Performance Computing Center Stuttgart,
 *                         University of Stuttgart.  All rights reserved.
 * Copyright (c) 2006-2008 The Center for Information Services and HPC
 *                         Technical University of Dresden.
 *                         All rights reserved.
 *
 * $COPYRIGHT$
 *
 * Additional copyrights may follow
 *
 * $HEADER$
 */
#pragma once

#define EXPORTING_DLL
#include "AddinComm.h"
#undef EXPORTING_DLL

namespace DICE_GUI
{

	class CDICE_AddinComm :
		public IAddinComm
	{
	private:
		CDICE_AddinComm(void);
		static CDICE_AddinComm* m_theInstance;

		bool m_isInitialDataSet;
		bool setInitialData (void);

		CWnd* m_diceWindow;
		HWND m_hWndDiceWindow;

	public:
		~CDICE_AddinComm(void);
		static CDICE_AddinComm* GetInstance(void);

		//set the DiceWindow HWND
		void setDiceWindow (CWnd* window, HWND hwndWindow);

		//incomming querys
		void popNewMarmotMsg (std::vector<std::string> messageparts);
		void popClear (void);

		//outgoing querys
		void pushOpenSourceFileLocation (std::string filename, int line);
		void pushOpenHTMLFile (std::string filename);
	};
		
} //end of namespace DICE_GUI