// DICE_ControlCtrl.cpp : Implementation of the CDICE_ControlCtrl ActiveX Control class.

#include "stdafx.h"
#include "DICE_Control.h"
#include "DICE_ControlCtrl.h"
#include "DICE_ControlPropPage.h"
#include "DICE_MessagesWin.h"
#include "DICE_LocationsWin.h"
#include "DICE_SystemWin.h"
#include "DICE_Interface.h"
#include "GUIUpdaterWin.h"
#include "DICE_QueryDiceImpl.h"
#include "DICE_QueryDice.h"
#include "DICE_ReportListWin.h"
#include "DICE_ReportWin.h"
#include "DICE_AddinComm.h"
#include <fstream>
#include <afxcview.h>
#include <assert.h>


#ifdef _DEBUG
#define new DEBUG_NEW
#endif

namespace DICE_GUI
{

IMPLEMENT_DYNCREATE(CDICE_ControlCtrl, COleControl)



// Message map

BEGIN_MESSAGE_MAP(CDICE_ControlCtrl, COleControl)
	ON_MESSAGE(OCM_COMMAND, &CDICE_ControlCtrl::OnOcmCommand)
	ON_OLEVERB(AFX_IDS_VERB_PROPERTIES, OnProperties)
	ON_WM_LBUTTONDOWN()
	ON_WM_SIZE()
	ON_WM_LBUTTONUP()
	ON_WM_CHAR()
	ON_WM_CREATE()
	ON_WM_LBUTTONDBLCLK()
END_MESSAGE_MAP()



// Dispatch map

BEGIN_DISPATCH_MAP(CDICE_ControlCtrl, COleControl)
END_DISPATCH_MAP()



// Event map

BEGIN_EVENT_MAP(CDICE_ControlCtrl, COleControl)
	EVENT_STOCK_MOUSEMOVE()
	EVENT_STOCK_CLICK()
END_EVENT_MAP()



// Property pages

// TODO: Add more property pages as needed.  Remember to increase the count!
BEGIN_PROPPAGEIDS(CDICE_ControlCtrl, 1)
	PROPPAGEID(CDICE_ControlPropPage::guid)
END_PROPPAGEIDS(CDICE_ControlCtrl)



// Initialize class factory and guid

IMPLEMENT_OLECREATE_EX(CDICE_ControlCtrl, "DICE_CONTROL.DICE_ControlCtrl.1",
	0x9d2cb887, 0xd6de, 0x4816, 0xab, 0x2a, 0xe4, 0x70, 0x23, 0x32, 0x72, 0xc6)



// Type library ID and version

IMPLEMENT_OLETYPELIB(CDICE_ControlCtrl, _tlid, _wVerMajor, _wVerMinor)



// Interface IDs

const IID BASED_CODE IID_DDICE_Control =
		{ 0x3254F15A, 0x4577, 0x4190, { 0xBC, 0x60, 0xA8, 0x9A, 0x2B, 0xB, 0x8A, 0x2A } };
const IID BASED_CODE IID_DDICE_ControlEvents =
		{ 0xFD542A18, 0x1EEA, 0x470B, { 0xB5, 0x2B, 0x80, 0x9C, 0x4C, 0xF5, 0x19, 0xE5 } };



// Control type information

static const DWORD BASED_CODE _dwDICE_ControlOleMisc =
	OLEMISC_ACTIVATEWHENVISIBLE |
	OLEMISC_SETCLIENTSITEFIRST |
	OLEMISC_INSIDEOUT |
	OLEMISC_CANTLINKINSIDE |
	OLEMISC_RECOMPOSEONRESIZE;

IMPLEMENT_OLECTLTYPE(CDICE_ControlCtrl, IDS_DICE_CONTROL, _dwDICE_ControlOleMisc)



// CDICE_ControlCtrl::CDICE_ControlCtrlFactory::UpdateRegistry -
// Adds or removes system registry entries for CDICE_ControlCtrl

BOOL CDICE_ControlCtrl::CDICE_ControlCtrlFactory::UpdateRegistry(BOOL bRegister)
{
	// TODO: Verify that your control follows apartment-model threading rules.
	// Refer to MFC TechNote 64 for more information.
	// If your control does not conform to the apartment-model rules, then
	// you must modify the code below, changing the 6th parameter from
	// afxRegApartmentThreading to 0.

	if (bRegister)
		return AfxOleRegisterControlClass(
			AfxGetInstanceHandle(),
			m_clsid,
			m_lpszProgID,
			IDS_DICE_CONTROL,
			IDB_DICE_CONTROL,
			afxRegApartmentThreading,
			_dwDICE_ControlOleMisc,
			_tlid,
			_wVerMajor,
			_wVerMinor);
	else
		return AfxOleUnregisterClass(m_clsid, m_lpszProgID);
}



// CDICE_ControlCtrl::CDICE_ControlCtrl - Constructor

CDICE_ControlCtrl::CDICE_ControlCtrl()
{
	InitializeIIDs(&IID_DDICE_Control, &IID_DDICE_ControlEvents);
	// TODO: Initialize your control's instance data here.
}



// CDICE_ControlCtrl::~CDICE_ControlCtrl - Destructor

CDICE_ControlCtrl::~CDICE_ControlCtrl()
{
	// TODO: Cleanup your control's instance data here.
}



// CDICE_ControlCtrl::OnDraw - Drawing function

void CDICE_ControlCtrl::OnDraw(
			CDC* pdc, const CRect& rcBounds, const CRect& rcInvalid)
{
	if (!pdc)
		return;

	DoSuperclassPaint(pdc, rcBounds);

	COLORREF rgbBack = 0x00FEFCFC;
	COLORREF rgbBorder = 0x009C9B91;

	//set the background color
	static bool isInited = false;
	static CBrush back, border;
	if (!isInited)
	{
		back.CreateSolidBrush(rgbBack);
		border.CreateSolidBrush(rgbBorder);
		isInited = true;		
	}
	pdc->FillRect(rcBounds, &back); //LTGRAY_BRUSH CBrush::FromHandle((HBRUSH)GetStockObject(WHITE_BRUSH))

	CRect rcLines[4], rcBack, rcBelowToolBar;
	rcBelowToolBar = rcBack = rcLines[0] = rcLines[1] = rcLines[2] = rcLines[3] = rcBounds;
	rcLines[0].top = rcBounds.bottom-1;
	rcLines[1].bottom = rcBounds.top+1;
	rcLines[2].left = rcBounds.right-1;
	rcLines[3].right = rcBounds.left+1;

	rcBack.top = 30;

	rcBelowToolBar.top = 24;
	rcBelowToolBar.bottom = 29;

	pdc->FillRect(rcBack, &back); //LTGRAY_BRUSH CBrush::FromHandle((HBRUSH)GetStockObject(WHITE_BRUSH))
	pdc->FillRect(rcLines[0], &border); //LTGRAY_BRUSH CBrush::FromHandle((HBRUSH)GetStockObject(WHITE_BRUSH))
	pdc->FillRect(rcLines[1], &border); //LTGRAY_BRUSH CBrush::FromHandle((HBRUSH)GetStockObject(WHITE_BRUSH))
	pdc->FillRect(rcLines[2], &border); //LTGRAY_BRUSH CBrush::FromHandle((HBRUSH)GetStockObject(WHITE_BRUSH))
	pdc->FillRect(rcLines[3], &border); //LTGRAY_BRUSH CBrush::FromHandle((HBRUSH)GetStockObject(WHITE_BRUSH))
	pdc->FillRect(rcBelowToolBar, &border); //LTGRAY_BRUSH CBrush::FromHandle((HBRUSH)GetStockObject(WHITE_BRUSH))

	//Add some text
	CRect rc = rcBounds;
	TEXTMETRIC tm;
	GetStockTextMetrics(&tm);
	GetTextMetrics(pdc->m_hDC,&tm); //TODO: This might cause compatibility problems see MSDN doku
	
	pdc->SetTextColor(RGB(0,0,0));//TranslateColor(GetForeColor()));
	pdc->SetTextAlign(TA_LEFT|TA_TOP);
	pdc->SetBkMode(TRANSPARENT);
	pdc->ExtTextOut(m_rectMessages.left,m_rectMessages.top-tm.tmHeight-3,ETO_CLIPPED, rc, _T("Messages"), std::string("Messages").length(), NULL);
	pdc->ExtTextOut(m_rectLocations.left,m_rectLocations.top-tm.tmHeight-3,ETO_CLIPPED, rc, _T("Locations"), std::string("Locations").length(), NULL);
	pdc->ExtTextOut(m_rectSystem.left,m_rectSystem.top-tm.tmHeight-3,ETO_CLIPPED, rc, _T("System"), std::string("System").length(), NULL);
	pdc->ExtTextOut(m_rectReportText.left,m_rectReportText.top-tm.tmHeight-3,ETO_CLIPPED, rc, _T("Details"), std::string("Details").length(), NULL);			
}



// CDICE_ControlCtrl::DoPropExchange - Persistence support

void CDICE_ControlCtrl::DoPropExchange(CPropExchange* pPX)
{
	ExchangeVersion(pPX, MAKELONG(_wVerMinor, _wVerMajor));
	COleControl::DoPropExchange(pPX);

	// TODO: Call PX_ functions for each persistent custom property.
}



// CDICE_ControlCtrl::OnResetState - Reset control to default state

void CDICE_ControlCtrl::OnResetState()
{
	COleControl::OnResetState();  // Resets defaults found in DoPropExchange

	// TODO: Reset any other control state here.
}



// CDICE_ControlCtrl::PreCreateWindow - Modify parameters for CreateWindowEx

BOOL CDICE_ControlCtrl::PreCreateWindow(CREATESTRUCT& cs)
{
	HRESULT hr = S_OK;

	cs.lpszClass = _T("STATIC");
	cs.lpszName = _T("");
	hr = COleControl::PreCreateWindow(cs);
	//InvalidateControl();

	return hr;
}

// CDICE_ControlCtrl::IsSubclassedControl - This is a subclassed control

BOOL CDICE_ControlCtrl::IsSubclassedControl()
{
	return TRUE;
}



// CDICE_ControlCtrl::OnOcmCommand - Handle command messages

LRESULT CDICE_ControlCtrl::OnOcmCommand(WPARAM wParam, LPARAM lParam)
{
#ifdef _WIN32
	WORD wNotifyCode = HIWORD(wParam);
#else
	WORD wNotifyCode = HIWORD(lParam);
#endif

	// TODO: Switch on wNotifyCode here.

	return 0;
}



// CDICE_ControlCtrl message handlers

void CDICE_ControlCtrl::OnLButtonDown(UINT nFlags, CPoint point)
{
	// TODO: Add your message handler code here and/or call default

	/*std::ofstream out("MyFile.txt",std::ios_base::app);
	out << "LButtonDown: " << point.x << " " << point.y << std::endl;
	out.close();*/

	COleControl::OnLButtonDown(nFlags, point);
}

void CDICE_ControlCtrl::OnSize(UINT nType, int cx, int cy)
{
	COleControl::OnSize(nType, cx, cy);

	// TODO: Add your message handler code here
	static bool initied = false;

	static CToolBarCtrl *m_wndToolBar  = new CToolBarCtrl();

	if (initied == false)
	{
		initied = true;
		/*std::ofstream out ("MyFile.txt");
		out << "Starting DICE Window" << std::endl;
		out.close();*/

		CDICE_AddinComm::GetInstance()->setDiceWindow(this,this->m_hWnd);

		if (!m_wndToolBar->Create(WS_CHILD | WS_VISIBLE | TBSTYLE_LIST| CBRS_TOOLTIPS |TBSTYLE_TOOLTIPS,CRect(0,0,10,10),this, 995 ))
			assert (0);

		m_wndToolBar->SetBitmapSize(CSize (16,16));
		int index = m_wndToolBar->AddBitmap (1,IDB_TOOLBAR);
		
		TBBUTTON buttons[6];
		buttons[0].iBitmap = index;
	    buttons[1].iBitmap = index+1;
		buttons[2].iBitmap = -1;
		buttons[3].iBitmap = index+2;		
		buttons[4].iBitmap = -1;		
		buttons[5].iBitmap = index+3;		
		buttons[0].idCommand = 1;
	    buttons[1].idCommand = 2; 
		buttons[2].idCommand = 0;
		buttons[3].idCommand = 3;
		buttons[4].idCommand = 0;
		buttons[5].idCommand = 4;
		buttons[0].fsState = buttons[1].fsState = buttons[2].fsState = buttons[3].fsState = buttons[4].fsState = buttons[5].fsState = TBSTATE_ENABLED;
		buttons[0].fsStyle = buttons[1].fsStyle = buttons[3].fsStyle = buttons[5].fsStyle = TBSTYLE_BUTTON;
		buttons[2].fsStyle = buttons[4].fsStyle = TBSTYLE_SEP;
		buttons[0].dwData = buttons[1].dwData = buttons[2].dwData = buttons[3].dwData = buttons[4].dwData = buttons[5].dwData = 0;
		buttons[0].iString = 0;
	    buttons[1].iString = 1;
		buttons[2].iString = -1;
		buttons[3].iString = 2;
		buttons[4].iString = -1;
		buttons[5].iString = 3;
		
		LPCTSTR str (L"Load\0Save\0Clear\0Info\0");
		m_wndToolBar->AddStrings (str);
		m_wndToolBar->AddButtons (6, buttons);		

		//1) set the Updater Query pointers
		DICE_INTERFACE::IDICE_QueryDice* query = DICE_BACK::CDICE_QueryDiceImpl::GetInstance();
		CDICE_GUIUpdaterWin::GetInstance()->setQueryDICE(query);		
		query->setGUIUpdater (CDICE_GUIUpdaterWin::GetInstance());
		
		//2) create the report text window
		CEdit *zz = CDICE_ReportWin::GetInstance();
		zz->Create(WS_VSCROLL|ES_READONLY|ES_MULTILINE|WS_BORDER|WS_CHILD|WS_VISIBLE,CRect(0,0,10,10),this,997);
		//WS_THICKFRAME ES_READONLY

		//3) Create the report List
		CListCtrl *xx = CDICE_ReportListWin::GetInstance();
		xx->Create (LVS_REPORT|LVS_ICON|LVS_SHOWSELALWAYS|LVS_SINGLESEL|WS_BORDER|WS_CHILD|WS_VISIBLE,CRect(0,0,10,10),this,998);
		//WS_THICKFRAME
		//LVS_REPORT , LVS_ICON
		
		//4) create the three Dimension windows
		for (int i = 0; i < 3; i++)
		{
			CTreeCtrl *yy;

			switch(i)
			{
			case 0:
				yy = CDICE_MessagesWin::GetInstance();
				break;
			case 1:
				yy = CDICE_LocationsWin::GetInstance();
				break;
			case 2:
				yy = CDICE_SystemWin::GetInstance();
				break;
			}
			yy->Create(WS_BORDER|WS_CHILD|WS_VISIBLE|WS_TABSTOP|TVS_HASLINES|TVS_HASBUTTONS|TVS_LINESATROOT|TVS_SHOWSELALWAYS,CRect(0,0,10,10),this,i+999);
			//WS_THICKFRAME
		}//end for			
	}//end if (!inited)

	//move the toolbar, even though that this doesn't works .... 
	m_wndToolBar->MoveWindow (2,0,cx-4,20);
	TBMETRICS toolBarMets;
	toolBarMets.cbSize = sizeof (toolBarMets);
	toolBarMets.cxBarPad = cx-4;
	toolBarMets.cyBarPad = 20;
	toolBarMets.cxButtonSpacing = 5;
	toolBarMets.cyButtonSpacing = 1;
	toolBarMets.cxPad = 5;
	toolBarMets.cyPad = 1;
	m_wndToolBar->SetMetrics(&toolBarMets);

	//move the three dimension windows
	for (int i = 0; i < 3; i++)
	{
		CTreeCtrl *yy;
		CRect* pRect = NULL;

		switch(i)
		{
		case 0:
			yy = CDICE_MessagesWin::GetInstance();
			pRect = &m_rectMessages;
			break;
		case 1:
			yy = CDICE_LocationsWin::GetInstance();
			pRect = &m_rectLocations;
			break;
		case 2:
			yy = CDICE_SystemWin::GetInstance();
			pRect = &m_rectSystem;
			break;
		}

		//Move all child Windows
		pRect->left = 40+((cx-80)/4 - 1)*i;
		pRect->top = 50;
		pRect->right = ((cx-80)/4);
		pRect->bottom = (cy-70)*0.6;
		yy->MoveWindow(pRect->left,pRect->top,pRect->right,pRect->bottom);
	}

	//move the report long text and report list windows
	m_rectReportList.left = 40;
	m_rectReportList.top = 50+(cy-70)*0.6-1;
	m_rectReportList.right = ((cx-80)/4)*3-2;
	m_rectReportList.bottom = (cy-70)*0.4;
	CDICE_ReportListWin::GetInstance()->MoveWindow(m_rectReportList.left,m_rectReportList.top,m_rectReportList.right,m_rectReportList.bottom);

	m_rectReportText.left = 40+((cx-80)/4-1)*3;
	m_rectReportText.top = 50;//20+(cy-40)*0.65;
	m_rectReportText.right = ((cx-80)/4)*1;
	m_rectReportText.bottom = (int)((cy-70)*0.6)+(int)((cy-70)*0.4)-1; 
	CDICE_ReportWin::GetInstance()->MoveWindow(m_rectReportText.left,m_rectReportText.top,m_rectReportText.right,m_rectReportText.bottom);
	
	/*std::ofstream out("MyFile.txt",std::ios_base::app);
	out << "New Size: " << cx << " " << cy << std::endl;
	out.close();*/
}

void CDICE_ControlCtrl::OnLButtonUp(UINT nFlags, CPoint point)
{
	// TODO: Add your message handler code here and/or call default
	/*std::ofstream out("MyFile.txt",std::ios_base::app);
	out << "LButtonUp: " << point.x << " " << point.y << std::endl;
	out.close();*/

	COleControl::OnLButtonUp(nFlags, point);
}

void CDICE_ControlCtrl::OnChar(UINT nChar, UINT nRepCnt, UINT nFlags)
{
	// TODO: Add your message handler code here and/or call default
	/*std::ofstream out("MyFile.txt",std::ios_base::app);
	out << "OnChar: " << nChar << " " << nRepCnt << std::endl;
	out.close();*/

	COleControl::OnChar(nChar, nRepCnt, nFlags);
}

int CDICE_ControlCtrl::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (COleControl::OnCreate(lpCreateStruct) == -1)
		return -1;

	// TODO:  Add your specialized creation code here
	/*std::ofstream out("MyFile.txt",std::ios_base::app);
	out << "OnCreate" << std::endl;
	out.close();*/
	
	return 0;
}

void CDICE_ControlCtrl::OnLButtonDblClk(UINT nFlags, CPoint point)
{
	// TODO: Add your message handler code here and/or call default
	/*std::ofstream out("MyFile.txt",std::ios_base::app);
	out << "LButtonDblClick: " << point.x << " " << point.y << std::endl;
	out.close();*/

	COleControl::OnLButtonDblClk(nFlags, point);
}

}//end of namespace DICE_GUI
BOOL DICE_GUI::CDICE_ControlCtrl::OnCmdMsg(UINT nID, int nCode, void* pExtra, AFX_CMDHANDLERINFO* pHandlerInfo)
{
	// TODO: Add your specialized code here and/or call the base class

	if (nCode == CN_COMMAND)
	{
		if (nID == 1) //ID for Load
		{
		    CString BASED_CODE szFilter = L"DICE Files (*.dice)|*.dice||";
			CFileDialog fileDlg(
				TRUE, L"dice", L"*.dice",
				OFN_FILEMUSTEXIST | OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,
				szFilter, this);

			if (fileDlg.DoModal() == IDOK)
			{
				std::ifstream file;
				file.open (fileDlg.GetPathName(),std::ios_base::in);
				CDICE_GUIUpdaterWin::GetInstance()->getQueryDICE()->load(file);
				file.close();
			}
		}

		if (nID == 2) //ID for Save
		{
		    CString BASED_CODE szFilter = L"DICE Files (*.dice)|*.dice||";
			CFileDialog fileDlg(
				FALSE, L"dice", L"*.dice",
				OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,
				szFilter, this);

			if (fileDlg.DoModal() == IDOK)
			{
				std::ofstream file;
				file.open (fileDlg.GetPathName(),std::ios_base::out);
				CDICE_GUIUpdaterWin::GetInstance()->getQueryDICE()->save(file);
				file.close();				
			}
		}

		if (nID == 3) //ID for Clear
		{
			//does the user wants to save first ?
			if (!CDICE_GUIUpdaterWin::GetInstance()->getQueryDICE()->isEmpty())
			{
				int ret = MessageBox(L"Do you want to save the current DICE data to a file ?", L"Save ?", MB_YESNO | MB_ICONQUESTION);
				if (ret == IDYES)
				{
					CString BASED_CODE szFilter = L"DICE Files (*.dice)|*.dice||";
					CFileDialog fileDlg(
						FALSE, L"dice", L"*.dice",
						OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,
						szFilter, this);

					if (fileDlg.DoModal() == IDOK)
					{
						std::ofstream file;
						file.open (fileDlg.GetPathName(),std::ios_base::out);
						CDICE_GUIUpdaterWin::GetInstance()->getQueryDICE()->save(file);
						file.close();				
					}
				}
			}//is the DICE empty ?

			//lets clear !
			CDICE_GUIUpdaterWin::GetInstance()->getQueryDICE()->clear();
		}

		if (nID == 4) //ID for Info
		{
			MessageBox(L"Marmot DICE Window:\r\n"
					   L"This display is part of the Marmot software and designed"
					   L" to visualize its output.\r\n\r\n"
					   L"For further information see the documentation provided"
					   L" in the Marmot installation directory.\r\n"
					   L"License information is provided in the Marmot installation directory.\r\n\r\n"
					   L"This display uses ideas from the CUBE display, developed by the"
					   L" Forchungszentrum Jlich, Federal Republic of Germany.\r\n\r\n"
					   L"Provided by:\r\n"
					   L"* The Center for Information Services and High Performance Computing,\r\n"
					   L"  Technische Universitt Dresden, Federal Republic of Germany\r\n"
					   L"* High Performance Computing Center Stuttgart,\r\n"
					   L"  University of Stuttgart, Federal Republic of Germany",
					  L"About", MB_OK | MB_ICONINFORMATION);
		}
	}

	if ((nID == 666) || (nCode == 777))
	{
		//Clear message from popClear
		DICE_INTERFACE::IDICE_QueryDice* query = CDICE_GUIUpdaterWin::GetInstance()->getQueryDICE();		
		
		//does the user wants to save first ?
		if (!query->isEmpty())
		{
			int ret = MessageBox(L"A new session will overwritte the current data, do you want to save first ?", L"Save ?", MB_YESNO | MB_ICONQUESTION);
			if (ret == IDYES)
			{
				CString BASED_CODE szFilter = L"DICE Files (*.dice)|*.dice||";
				CFileDialog fileDlg(					
					FALSE, L"dice", L"*.dice",
					OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,
					szFilter, this);

 				if (fileDlg.DoModal() == IDOK)
				{
					std::ofstream file;
					file.open (fileDlg.GetPathName(),std::ios_base::out);
					CDICE_GUIUpdaterWin::GetInstance()->getQueryDICE()->save(file);
					file.close();				
				}
			}
		}//is the DICE empty ?

		//lets clear !
		CDICE_GUIUpdaterWin::GetInstance()->getQueryDICE()->clear();
	}

	return COleControl::OnCmdMsg(nID, nCode, pExtra, pHandlerInfo);
}
