/*
 * Copyright (c) 2002-2008 High Performance Computing Center Stuttgart,
 *                         University of Stuttgart.  All rights reserved.
 * Copyright (c) 2006-2008 The Center for Information Services and HPC
 *                         Technical University of Dresden.
 *                         All rights reserved.
 *
 * $COPYRIGHT$
 *
 * Additional copyrights may follow
 *
 * $HEADER$
 */
#pragma once

namespace DICE_GUI
{

// DICE_ControlCtrl.h : Declaration of the CDICE_ControlCtrl ActiveX Control class.


// CDICE_ControlCtrl : See DICE_ControlCtrl.cpp for implementation.

class CDICE_ControlCtrl : public COleControl
{
	DECLARE_DYNCREATE(CDICE_ControlCtrl)

// Constructor
public:
	CDICE_ControlCtrl();

// Attributed
public:
	//positions and sizes of the child windows
	CRect m_rectMessages;
	CRect m_rectLocations;
	CRect m_rectSystem;
	CRect m_rectReportList;
	CRect m_rectReportText;

// Overrides
public:
	virtual void OnDraw(CDC* pdc, const CRect& rcBounds, const CRect& rcInvalid);
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual void DoPropExchange(CPropExchange* pPX);
	virtual void OnResetState();

// Implementation
protected:
	~CDICE_ControlCtrl();

	DECLARE_OLECREATE_EX(CDICE_ControlCtrl)    // Class factory and guid
	DECLARE_OLETYPELIB(CDICE_ControlCtrl)      // GetTypeInfo
	DECLARE_PROPPAGEIDS(CDICE_ControlCtrl)     // Property page IDs
	DECLARE_OLECTLTYPE(CDICE_ControlCtrl)		// Type name and misc status

	// Subclassed control support
	BOOL IsSubclassedControl();
	LRESULT OnOcmCommand(WPARAM wParam, LPARAM lParam);

// Message maps
	DECLARE_MESSAGE_MAP()

// Dispatch maps
	DECLARE_DISPATCH_MAP()

// Event maps
	DECLARE_EVENT_MAP()

// Dispatch and event IDs
public:
	enum {
	};
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnChar(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnLButtonDblClk(UINT nFlags, CPoint point);
	virtual BOOL OnCmdMsg(UINT nID, int nCode, void* pExtra, AFX_CMDHANDLERINFO* pHandlerInfo);
};

}