/*
 * Copyright (c) 2002-2008 High Performance Computing Center Stuttgart,
 *                         University of Stuttgart.  All rights reserved.
 * Copyright (c) 2006-2008 The Center for Information Services and HPC
 *                         Technical University of Dresden.
 *                         All rights reserved.
 *
 * $COPYRIGHT$
 *
 * Additional copyrights may follow
 *
 * $HEADER$
 */
#pragma once
#include "dice_dataitem.h"

namespace DICE_BACK
{
	class CDICE_DataLeaf : public CDICE_DataItem
	{
	protected:
		double m_severity;
		std::list<SDICE_LinkType> m_link;

	public:
		CDICE_DataLeaf(void);
		CDICE_DataLeaf(std::string desc, long DICE_id,double severity);
		~CDICE_DataLeaf(void);

		double getSeverity (void);
		void setSeverity (double);
		void addSeverity (double);

		std::list<SDICE_LinkType> getLinks (void);
		void addLink (long locationsID, long systemID, double severity);

		double calculateSeverity (void);
		std::list<SDICE_LinkType> accumulateLinks (void);
		bool isLeaf (void);
		DICE_INTERFACE::CDICE_TreeItem* copyToInterfaceTree (void);
		DICE_INTERFACE::CDICE_TreeItem* copyToInterfaceTreeWeighted (std::list<std::pair<long,double> > weights);
		bool deleteTree (void);
		bool save (std::ofstream &file);
		bool load (std::ifstream &file);
	};

} //end of namespace DICE_BACK