/*
 * Copyright (c) 2002-2008 High Performance Computing Center Stuttgart,
 *                         University of Stuttgart.  All rights reserved.
 * Copyright (c) 2006-2008 The Center for Information Services and HPC
 *                         Technical University of Dresden.
 *                         All rights reserved.
 *
 * $COPYRIGHT$
 *
 * Additional copyrights may follow
 *
 * $HEADER$
 */
#pragma once
#include "dice_dataitem.h"
#include <list>

namespace DICE_BACK
{

	class CDICE_DataNode : public CDICE_DataItem
	{
	protected:
		std::list<CDICE_DataItem*> m_childs;

	public:
		CDICE_DataNode(void);
		CDICE_DataNode(std::string desc, long DICE_id);
		~CDICE_DataNode(void);

		std::list<CDICE_DataItem*> getChilds(void);
		void addChild (CDICE_DataItem*);

		double calculateSeverity (void);
		std::list<SDICE_LinkType> accumulateLinks (void);
		CDICE_DataItem* findDICEid (long);
		long findDesc (std::string desc);
		bool isLeaf (void);
		std::list<long> accumulateIDs (void);
		DICE_INTERFACE::CDICE_TreeItem* copyToInterfaceTree (void);
		DICE_INTERFACE::CDICE_TreeItem* copyToInterfaceTreeWeighted (std::list<std::pair<long,double> > weights);
		bool deleteTree (void);
		bool save (std::ofstream &file);
		bool load (std::ifstream &file);
	};

}//end of namespace DIVE_BACK