/*
 * Copyright (c) 2002-2008 High Performance Computing Center Stuttgart,
 *                         University of Stuttgart.  All rights reserved.
 * Copyright (c) 2006-2008 The Center for Information Services and HPC
 *                         Technical University of Dresden.
 *                         All rights reserved.
 *
 * $COPYRIGHT$
 *
 * Additional copyrights may follow
 *
 * $HEADER$
 */
#pragma once
#include "dice_querydice.h"

namespace DICE_BACK
{
	class CDICE_QueryDiceImpl :	public DICE_INTERFACE::IDICE_QueryDice
	{
	protected:
		CDICE_QueryDiceImpl(void);
		static CDICE_QueryDiceImpl* m_theInstance;
		DICE_INTERFACE::IDICE_GUIUpdater* m_pUpdater;
		DICE_INTERFACE::SDICE_ReturnIDs m_curSelection;
		int m_avoidGUIUpdate;
		bool m_systemDirty,
			 m_messagesDirty,
			 m_locationsDirty,
			 m_reportsDirty;
		long m_lastSelMessages,
			 m_lastSelLocations,
			 m_lastSelSystem;

		void UpdateGUI (void);

	public:
		~CDICE_QueryDiceImpl(void);
		static CDICE_QueryDiceImpl* GetInstance(void);

		void setGUIUpdater (DICE_INTERFACE::IDICE_GUIUpdater* pUpdater);
		DICE_INTERFACE::IDICE_GUIUpdater* getGUIUpdater (void);

		DICE_INTERFACE::SDICE_ReturnIDs AddEntry (
			std::string messagesParent,
			std::string messagesDesc,
			std::string locationsParent,
			std::string locationsDesc,
			std::string systemParent,
			std::string systemDesc,
			double severity,
			DICE_INTERFACE::CDICE_Message msg);

		DICE_INTERFACE::SDICE_ReturnIDs AddEntry (
			std::string messagesParent,
			std::string messagesDesc,
			std::string locationsParent,
			std::string locationsDesc,
			std::string systemParent,
			std::string systemDesc,
			double severity);

		DICE_INTERFACE::SDICE_ReturnIDs AddEntry (
			long messagesParent,
			std::string messagesDesc,
			long locationsParent,
			std::string locationsDesc,
			long systemParent,
			std::string systemDesc,
			double severity,
			DICE_INTERFACE::CDICE_Message msg);

		DICE_INTERFACE::SDICE_ReturnIDs AddEntry (
			long messagesParent,
			std::string messagesDesc,
			long locationsParent,
			std::string locationsDesc,
			long systemParent,
			std::string systemDesc,
			double severity);

		DICE_INTERFACE::SDICE_ReturnIDs AddEntry (
			long messagesParent,
			long messagesID,
			long locationsParent,
			long locationsID,
			long systemParent,
			long systemID,
			double severity,
			DICE_INTERFACE::CDICE_Message msg);

		DICE_INTERFACE::SDICE_ReturnIDs AddEntry (
			long messagesParent,
			long messagesID,
			long locationsParent,
			long locationsID,
			long systemParent,
			long systemID,
			double severity);

		long AddMessagesItem (std::string parentName, std::string itemName, bool bLeaf);
		long AddMessagesItem (long parentID, std::string itemName, bool bLeaf);
		long AddLocationsItem (std::string parentName, std::string itemName, bool bLeaf);
		long AddLocationsItem (long parentID, std::string itemName, bool bLeaf);
		long AddSystemItem (std::string parentName, std::string itemName, bool bLeaf);
		long AddSystemItem (long parentID, std::string itemName, bool bLeaf);

		bool changeSelection (DICE_INTERFACE::SDICE_ReturnIDs selection);
		bool changeMessagesSelection (long id);
		bool changeLocationsSelection (long id);
		bool changeSystemSelection (long id);

		std::list<DICE_INTERFACE::CDICE_Message> getReports (DICE_INTERFACE::SDICE_ReturnIDs selection);

		bool clear (void);
		bool save (std::ofstream &file);
		bool load (std::ifstream &file);

		bool isEmpty (void);
	};
}