#include "StdAfx.h"
#include "DICE_SystemData.h"

namespace DICE_BACK
{
	CDICE_SystemData* CDICE_SystemData::m_theInstance = NULL;

	CDICE_SystemData::CDICE_SystemData(void)
	{
	}

	CDICE_SystemData::~CDICE_SystemData(void)
	{
	}

	CDICE_SystemData* CDICE_SystemData::GetInstance (void)
	{
		if (m_theInstance == NULL)
		{
			m_theInstance = new CDICE_SystemData();
		}

		return m_theInstance;
	}

	std::list<SDICE_LinkType> CDICE_SystemData::restrictLinksToLocationsSelection (std::list<SDICE_LinkType> links, std::list<long> restriction)
	{
		std::list<SDICE_LinkType> ret;
		ret.clear();

		std::list<SDICE_LinkType>::iterator i;
		for (i = links.begin();i != links.end();i++)
		{
			std::list<long>::iterator j;
			for (j = restriction.begin(); j != restriction.end();j++)
			{
				if (i->locationsID == *j)
				{
					ret.push_back(*i);
					break;
				}
			}
		}

		return ret;
	}

	DICE_INTERFACE::CDICE_TreeItem* CDICE_SystemData::createRestrictedInterfaceTree (std::list<SDICE_LinkType> links)
	{
		std::list<std::pair<long,double> > temp;
		temp.clear();

		std::list<SDICE_LinkType>::iterator i;
		for (i = links.begin(); i != links.end(); i++)
		{
			//i->systemID might already be present ...
			double sev = i->severity;
			std::list<std::pair<long,double> >::iterator j;
			for (j = temp.begin();j != temp.end();j++)
			{
				if (j->first == i->systemID)
				{
					sev += j->second;
					temp.erase(j);
					break;
				}
			}
			temp.push_back (std::make_pair (i->systemID,sev));
		}

		return createWeightedInterfaceTree (temp);
	}

} //end of namespace DICE_BACK