#include "StdAfx.h"
#include "DICE_TreeNode.h"

namespace DICE_INTERFACE
{

	CDICE_TreeNode::CDICE_TreeNode(void)
	{
		m_childs.clear();
	}

	CDICE_TreeNode::CDICE_TreeNode(CDICE_TreeItem* father, std::string desc, double severity, long DICE_id)
		: CDICE_TreeItem (father,desc,severity,DICE_id)
	{
		m_childs.clear();
	}

	CDICE_TreeNode::~CDICE_TreeNode(void)
	{
		std::list<CDICE_TreeItem*>::iterator i;

		for (i = m_childs.begin();i != m_childs.end(); i++)
		{
			if (*i != NULL)
				delete (*i);
		}

		m_childs.clear();
	}

	std::list<CDICE_TreeItem*> CDICE_TreeNode::getChilds (void)
	{
		return m_childs;
	}
	
	void CDICE_TreeNode::addChild (CDICE_TreeItem* child)
	{
		m_childs.push_back (child);
		child->setFather(this);
	}

	bool CDICE_TreeNode::isLeaf (void)
	{
		return false;
	}

	double CDICE_TreeNode::accumulateSeverities (void)
	{
		double ret = m_severity;

		std::list<CDICE_TreeItem*>::iterator i;
		for (i = m_childs.begin();i != m_childs.end(); i++)
		{
			if (*i == NULL)
				continue; //should not happen ....

			ret += (*i)->getSeverity();
		}

		return ret;
	}

	CDICE_TreeItem* CDICE_TreeNode::findDICEid (long DICE_id)
	{
		CDICE_TreeItem* temp = CDICE_TreeItem::findDICEid(DICE_id);

		if (temp)
			return temp;

		//recursion
		std::list<CDICE_TreeItem*>::iterator i;
		for (i = m_childs.begin();i != m_childs.end(); i++)
		{
			temp = (*i)->findDICEid(DICE_id);
			if (temp)
				return temp;
		}

		return NULL;
	}

} //end of namespace DICE_INTERFACE