/*
 * Copyright (c) 2002-2008 High Performance Computing Center Stuttgart,
 *                         University of Stuttgart.  All rights reserved.
 * Copyright (c) 2006-2008 The Center for Information Services and HPC
 *                         Technical University of Dresden.
 *                         All rights reserved.
 *
 * $COPYRIGHT$
 *
 * Additional copyrights may follow
 *
 * $HEADER$
 */
#pragma once
#include "stdafx.h"
#include "afxcmn.h"
#include "DICE_TreeItem.h"
#include "DICE_TreeNode.h"
#include "DICE_TreeLeaf.h"
#include <list>

namespace DICE_GUI
{

	class CDICE_TreeWin : public CTreeCtrl
	{
	protected:
		//pairs each tree entry with the DICE id
		std::list<std::pair<HTREEITEM,long> > m_items;
		std::list<long> m_expandedList;
		CImageList* m_imageList;
		long m_selectedID;

		bool addItemRecursive(DICE_INTERFACE::CDICE_TreeItem* item,HTREEITEM parent, double max_sev);
		long getDICEidForTreeITem (HTREEITEM item);
		HTREEITEM getTreeItemForDICEid (long id);

	public:
		CDICE_TreeWin(void);
		~CDICE_TreeWin(void);

		bool updateContent (DICE_INTERFACE::CDICE_TreeItem* tree);
		virtual void selectionChanged(long DICEid) = 0;
		long getSelection (void);

		// Message maps
		DECLARE_MESSAGE_MAP()

		// Dispatch maps
		DECLARE_DISPATCH_MAP()

		// Dispatch and event IDs
	public:
		enum {
		};

		afx_msg void OnTvnItemChanged(NMHDR *pNMHDR, LRESULT *pResult);
		afx_msg void OnTvnItemexpanded(NMHDR *pNMHDR, LRESULT *pResult);
		afx_msg void OnTvnSelchanged(NMHDR *pNMHDR, LRESULT *pResult);
		afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	};

} //end of namespace DICE_GUI