/*
 * Copyright (c) 2002-2008 High Performance Computing Center Stuttgart,
 *                         University of Stuttgart.  All rights reserved.
 * Copyright (c) 2006-2008 The Center for Information Services and HPC
 *                         Technical University of Dresden.
 *                         All rights reserved.
 *
 * $COPYRIGHT$
 *
 * Additional copyrights may follow
 *
 * $HEADER$
 */
#pragma once

#include "DICE_TreeItem.h"
#include "DICE_Message.h"
#include <list>

namespace DICE_INTERFACE
{

	class IDICE_GUIUpdater
	{
	protected:
		IDICE_GUIUpdater(void);
	
	public:
		~IDICE_GUIUpdater(void);
		
		/**
		 * @param tree the new content represented as CDICE_TreeItem
		 *        if implementation needs the tree for further usage 
		 *        it must create a copy of the tree.
		 *        (The pointer might not be valid after this call is 
		 *         finished)
		 */
		virtual bool updateMessages (CDICE_TreeItem *tree) = 0;
		virtual bool updateLocations (CDICE_TreeItem *tree) = 0;
		virtual bool updateSystem (CDICE_TreeItem *tree) = 0;
		virtual bool updateReportList (std::list<CDICE_Message> reports) = 0;
	};

} //end of namespace DICE_INTERFACE