#include "StdAfx.h"
#include "GUIUpdaterWin.h"
#include "DICE_MessagesWin.h"
#include "DICE_LocationsWin.h"
#include "DICE_SystemWin.h"
#include "DICE_ReportListWin.h"

namespace DICE_GUI
{
	CDICE_GUIUpdaterWin* CDICE_GUIUpdaterWin::m_theInstance = NULL;

	CDICE_GUIUpdaterWin::CDICE_GUIUpdaterWin(void)
	{
		m_queryDICE = NULL;
	}

	CDICE_GUIUpdaterWin::~CDICE_GUIUpdaterWin(void)
	{
	}

	CDICE_GUIUpdaterWin* CDICE_GUIUpdaterWin::GetInstance (void)
	{
		if (m_theInstance == NULL)
		{
			m_theInstance = new CDICE_GUIUpdaterWin ();
		}

		return m_theInstance;
	}

	bool CDICE_GUIUpdaterWin::updateMessages (DICE_INTERFACE::CDICE_TreeItem *tree)
	{
		return CDICE_MessagesWin::GetInstance()->updateContent(tree);
	}

	bool CDICE_GUIUpdaterWin::updateLocations (DICE_INTERFACE::CDICE_TreeItem *tree)
	{
		return CDICE_LocationsWin::GetInstance()->updateContent(tree);
	}

	bool CDICE_GUIUpdaterWin::updateSystem (DICE_INTERFACE::CDICE_TreeItem *tree)
	{
		return CDICE_SystemWin::GetInstance()->updateContent(tree);
	}

	bool CDICE_GUIUpdaterWin::updateReportList (std::list<DICE_INTERFACE::CDICE_Message> reports)
	{
		CDICE_ReportListWin::GetInstance()->setReports(reports);
		return true; //TODO: handle return values !!!
	}

	void CDICE_GUIUpdaterWin::setQueryDICE (DICE_INTERFACE::IDICE_QueryDice* query)
	{
		m_queryDICE = query;
	}

	DICE_INTERFACE::IDICE_QueryDice* CDICE_GUIUpdaterWin::getQueryDICE (void)
	{
		return m_queryDICE;
	}

} //end of namespace DICE_GUI