/*
 * Copyright (c) 2002-2008 High Performance Computing Center Stuttgart,
 *                         University of Stuttgart.  All rights reserved.
 * Copyright (c) 2006-2008 The Center for Information Services and HPC
 *                         Technical University of Dresden.
 *                         All rights reserved.
 *
 * $COPYRIGHT$
 *
 * Additional copyrights may follow
 *
 * $HEADER$
 */
#pragma once

#ifdef USE_MARMOT_DICE

#include <string>
#include <vector>

class IAddinComm;
class IToolWinComm;

#ifdef EXPORTING_DLL
#define DLL_EXP __declspec(dllexport)
#else
#define DLL_EXP __declspec(dllimport)
#endif

/**
 * Interface used for the ToolWindow to conntact the Addin.
 * This header must not include any ATL/EnvDTE headers 
 * otherwise the linker will get mad ! 
 * (The ToolWindow will include this header!)
 **/

class DLL_EXP IToolWinComm
{
protected:
	IAddinComm* m_pToolWinObject;
	IToolWinComm(void);

public:	
	~IToolWinComm(void);
	void setToolWinObject (IToolWinComm *pMe);

	//outgoing querys
	virtual void pushNewMarmotMsg (std::vector<std::string> messageparts) = 0;
	virtual void pushClear (void) = 0;

	//incoming querys
	virtual void popOpenSourceFileLocation (std::string filename,int line) = 0;
	virtual void popOpenHTMLFile (std::string filename) = 0;
};

#undef EXPORTING_DLL
#include "AddinComm.h"

#endif //USE_MARMOT_DICE