/*
 * Copyright (c) 2002-2008 High Performance Computing Center Stuttgart,
 *                         University of Stuttgart.  All rights reserved.
 * Copyright (c) 2006-2008 The Center for Information Services and HPC
 *                         Technical University of Dresden.
 *                         All rights reserved.
 *
 * $COPYRIGHT$
 *
 * Additional copyrights may follow
 *
 * $HEADER$
 */
#pragma once

#ifdef USE_MARMOT_DICE

#define EXPORTING_DLL
#include "IToolWinComm.h"
#undef EXPORTING_DLL
#include "stdafx.h"
using namespace EnvDTE;
using namespace EnvDTE80;

/**
 * Class that communicates with the DICE window.
 * Uses Singleton pattern to make it available
 * everywhere.
 * Is two way communicating:
 *  * used to pass Marmot messages to the ToolWindow
 *  * used to execute querys of the ToolWindow
 *    -> "open sourcefile"
 *    -> maybe "show HTML Standard reference"
 *
 * TODO: might need mutual exclusion ....
 */
class CToolWinComm : public IToolWinComm
{
private:
	static CToolWinComm* m_theInstance;
	CToolWinComm(CComPtr<DTE2> pDTE, CComPtr<AddIn> pAddInInstance, CComPtr<OutputWindowPane> m_pBuildOutput);

protected:
	CComPtr<DTE2> m_pDTE;
	CComPtr<AddIn> m_pAddInInstance;
	CComPtr<OutputWindowPane> m_pBuildOutput;

public:
	~CToolWinComm(void);
	static CToolWinComm* InitInstance (CComPtr<DTE2> pDTE, CComPtr<AddIn> pAddInInstance, CComPtr<OutputWindowPane> m_pBuildOutput);
	static CToolWinComm* GetInstance (void); //only valid if InitInstance was called before

	//outgoing querys 
	void pushNewMarmotMsg (std::vector<std::string> messageparts);
	void pushClear (void);

	//incoming querys
	void popOpenSourceFileLocation (std::string filename,int line);
	void popOpenHTMLFile (std::string filename);
};

#endif //USE_MARMOT_DICE