#ifdef USE_MARMOT_DICE

#include "Win_DiceWindow.h"
#include "ToolWinComm.h"
#include <assert.h>

CWin_DiceWindow* CWin_DiceWindow::m_theInstance = NULL;

CWin_DiceWindow::CWin_DiceWindow(void)
{
}

CWin_DiceWindow::~CWin_DiceWindow(void)
{
}

HRESULT CWin_DiceWindow::create(CComPtr<DTE2> pDTE, CComPtr<AddIn> pAddInInstance,CComPtr<OutputWindowPane> m_pBuildOutput)
{
	HRESULT hr = S_OK;
	CComPtr<EnvDTE::Windows> the_windows;
	CComPtr<IDispatch> pProgrammableObject;
	CComVariant varBitmap;
	CComPtr<IDispatch> pToolObject;

	//Create the tool window
	IfFailGoCheck(pDTE->get_Windows(&the_windows), the_windows);	

	IfFailGoCheck(the_windows->CreateToolWindow(pAddInInstance, CComBSTR("DICE_CONTROL.DICE_ControlCtrl.1"), CComBSTR("Marmot DICE"), CComBSTR("{B8DCB086-5D26-4f18-821D-FA1BA25512B5}"), &pProgrammableObject, &pWindow),pWindow);

	//set some stuff for the window
	//TODO: the tab picture seems not to work correctly !!
	HBITMAP hToolWindowBitmap = LoadBitmap(_AtlModule.GetResourceInstance(), (LPCSTR)IDB_DICE_CONTROL);
	pWindow->put_Visible(VARIANT_TRUE);
	
	varBitmap.vt = VT_INT;
	varBitmap.intVal = (INT)hToolWindowBitmap;
	pWindow->SetTabPicture(varBitmap);	
	pWindow->put_Linkable(VARIANT_TRUE);
	
	//start communication object to talk with the tool window
	CToolWinComm::InitInstance(pDTE,pAddInInstance,m_pBuildOutput);	

	return hr;

Error:
	return hr;
}

void CWin_DiceWindow::putVisible (void)
{
	pWindow->put_Visible(VARIANT_TRUE);
}

HRESULT CWin_DiceWindow::close (void)
{
	HRESULT hr = S_OK;

	if (pWindow)
		hr = pWindow->Close(EnvDTE::vsSaveChanges::vsSaveChangesPrompt);
	pWindow = NULL;

	return hr;
}

CWin_DiceWindow* CWin_DiceWindow::GetInstance(void)
{
	if (!m_theInstance)
	{
		m_theInstance = new CWin_DiceWindow();
		assert (m_theInstance);
	}

	return m_theInstance;
}

#endif //USE_MARMOT_DICE