/*
 * Copyright (c) 2002-2008 High Performance Computing Center Stuttgart,
 *                         University of Stuttgart.  All rights reserved.
 * Copyright (c) 2006-2008 The Center for Information Services and HPC
 *                         Technical University of Dresden.
 *                         All rights reserved.
 *
 * $COPYRIGHT$
 *
 * Additional copyrights may follow
 *
 * $HEADER$
 */
#include <QtGui>
#include "ExeThread.h"

#if !defined(DEBUG) && !defined(_DEBUG)
#define QT_NO_DEBUG_OUTPUT
#endif

ExeThread::ExeThread(QObject *parent) : QThread(parent)
{
  qDebug("DEBUG: ExeThread::ExeThread called");
}

ExeThread::~ExeThread()
{
  qDebug("DEBUG: ExeThread::~ExeThread() called");
}

void ExeThread::run()
{
	int ret;	// holds the return value of the command
  qDebug("DEBUG: ExeThread::run() called");
	ret = system(qPrintable(m_command)); // issue the command, get return value
  qDebug("DEBUG: ExeThread::run(): ret = %d", ret);
  qDebug("DEBUG: ExeThread::run() before exit\n");
  emit commanddone(ret);  // signal the GUI
}

void ExeThread::cancel()
{
  qDebug("DEBUG: ExeThread::cancel() called");
	m_abort = true;
}

void ExeThread::runexe(QString command)
{
  qDebug("DEBUG: ExeThread::runexe(%s) called\n", qPrintable(command));
	m_command = command;
	if (!isRunning())	//is the thread already running?
	{
		start(LowPriority);	//start with low priority
	}
	else			//thread is already running; do nothing
	{
    qDebug("DEBUG: ExeThread already running");
	}
}

	

