/*
 * Copyright (c) 2002-2008 High Performance Computing Center Stuttgart,
 *                         University of Stuttgart.  All rights reserved.
 * Copyright (c) 2006-2008 The Center for Information Services and HPC
 *                         Technical University of Dresden.
 *                         All rights reserved.
 *
 * $COPYRIGHT$
 *
 * Additional copyrights may follow
 *
 * $HEADER$
 */
//#include <string>
//#include <iostream>
#include "MarmotErrCodes.h"

#if !defined(DEBUG) && !defined(_DEBUG)
#define QT_NO_DEBUG_OUTPUT
#endif

MarmotErrCodes::MarmotErrCodes(MarmotGUIConfiguration *conf,QWidget *parent)
{
	m_Conf=conf;
	setupUi(this);// this sets up the GUI
	qDebug("DEBUG: MarmotErrCodes::MarmotErrCodes called\n");
	//qDebug("DEBUG: just a test... m_Conf->getExeNumprocs()=%i",m_Conf->getExeNumprocs());
	setupConnections();
	//resetSelection(1);
	getSelectionFromConf();
}
MarmotErrCodes::MarmotErrCodes(QWidget *parent)
{
	    setupUi(this); // this sets up GUI
}

void MarmotErrCodes::setupConnections()
{
	//errors
	connect( comm_err_disable_radioButton, SIGNAL ( clicked() ), this, SLOT ( disable_clicked() ) );
	connect( buffer_err_disable_radioButton, SIGNAL ( clicked() ), this, SLOT ( disable_clicked() ) );
	connect( type_err_disable_radioButton, SIGNAL ( clicked() ), this, SLOT ( disable_clicked() ) );
	connect( request_err_disable_radioButton, SIGNAL ( clicked() ), this, SLOT ( disable_clicked() ) );
	connect( rank_err_disable_radioButton, SIGNAL ( clicked() ), this, SLOT ( disable_clicked() ) );
	connect( io_err_disable_radioButton, SIGNAL ( clicked() ), this, SLOT ( disable_clicked() ) );
	connect( misc_err_disable_radioButton, SIGNAL ( clicked() ), this, SLOT ( disable_clicked() ) );
	
	connect( comm_err_enable_radioButton, SIGNAL ( clicked() ), this, SLOT ( enable_clicked() ) );
	connect( buffer_err_enable_radioButton, SIGNAL ( clicked() ), this, SLOT ( enable_clicked() ) );
	connect( type_err_enable_radioButton, SIGNAL ( clicked() ), this, SLOT ( enable_clicked() ) );
	connect( request_err_enable_radioButton, SIGNAL ( clicked() ), this, SLOT ( enable_clicked() ) );
	connect( rank_err_enable_radioButton, SIGNAL ( clicked() ), this, SLOT ( enable_clicked() ) );
	connect( io_err_enable_radioButton, SIGNAL ( clicked() ), this, SLOT ( enable_clicked() ) );
	connect( misc_err_enable_radioButton, SIGNAL ( clicked() ), this, SLOT ( enable_clicked() ) );
	
	connect( comm_err_selection_radioButton, SIGNAL ( clicked() ), this, SLOT ( selection_clicked() ) );
	connect( buffer_err_selection_radioButton, SIGNAL ( clicked() ), this, SLOT ( selection_clicked() ) );
	connect( type_err_selection_radioButton, SIGNAL ( clicked() ), this, SLOT ( selection_clicked() ) );
	connect( request_err_selection_radioButton, SIGNAL ( clicked() ), this, SLOT ( selection_clicked() ) );
	connect( rank_err_selection_radioButton, SIGNAL ( clicked() ), this, SLOT ( selection_clicked() ) );
	connect( io_err_selection_radioButton, SIGNAL ( clicked() ), this, SLOT ( selection_clicked() ) );
	connect( misc_err_selection_radioButton, SIGNAL ( clicked() ), this, SLOT ( selection_clicked() ) );
	//warnings
	connect( type_warn_disable_radioButton, SIGNAL ( clicked() ), this, SLOT ( disable_clicked() ) );
	connect( request_warn_disable_radioButton, SIGNAL ( clicked() ), this, SLOT ( disable_clicked() ) );
	connect( comm_warn_disable_radioButton, SIGNAL ( clicked() ), this, SLOT ( disable_clicked() ) );
	connect( rank_warn_disable_radioButton, SIGNAL ( clicked() ), this, SLOT ( disable_clicked() ) );
	connect( thread_warn_disable_radioButton, SIGNAL ( clicked() ), this, SLOT ( disable_clicked() ) );
	connect( misc_warn_disable_radioButton, SIGNAL ( clicked() ), this, SLOT ( disable_clicked() ) );

	connect( type_warn_enable_radioButton, SIGNAL ( clicked() ), this, SLOT ( enable_clicked() ) );
	connect( request_warn_enable_radioButton, SIGNAL ( clicked() ), this, SLOT ( enable_clicked() ) );
	connect( comm_warn_enable_radioButton, SIGNAL ( clicked() ), this, SLOT ( enable_clicked() ) );
	connect( rank_warn_enable_radioButton, SIGNAL ( clicked() ), this, SLOT ( enable_clicked() ) );
	connect( thread_warn_enable_radioButton, SIGNAL ( clicked() ), this, SLOT ( enable_clicked() ) );
	connect( misc_warn_enable_radioButton, SIGNAL ( clicked() ), this, SLOT ( enable_clicked() ) );

	connect( type_warn_selection_radioButton, SIGNAL ( clicked() ), this, SLOT ( selection_clicked() ) );
	connect( request_warn_selection_radioButton, SIGNAL ( clicked() ), this, SLOT ( selection_clicked() ) );
	connect( comm_warn_selection_radioButton, SIGNAL ( clicked() ), this, SLOT ( selection_clicked() ) );
	connect( rank_warn_selection_radioButton, SIGNAL ( clicked() ), this, SLOT ( selection_clicked() ) );
	connect( thread_warn_selection_radioButton, SIGNAL ( clicked() ), this, SLOT ( selection_clicked() ) );
	connect( misc_warn_selection_radioButton, SIGNAL ( clicked() ), this, SLOT ( selection_clicked() ) );
	//notes
	connect( type_note_disable_radioButton, SIGNAL ( clicked() ), this, SLOT ( disable_clicked() ) );
	connect( misc_note_disable_radioButton, SIGNAL ( clicked() ), this, SLOT ( disable_clicked() ) );

	connect( type_note_enable_radioButton, SIGNAL ( clicked() ), this, SLOT ( enable_clicked() ) );
	connect( misc_note_enable_radioButton, SIGNAL ( clicked() ), this, SLOT ( enable_clicked() ) );

	connect( type_note_selection_radioButton, SIGNAL ( clicked() ), this, SLOT ( selection_clicked() ) );
	connect( misc_note_selection_radioButton, SIGNAL ( clicked() ), this, SLOT ( selection_clicked() ) );
	//errcodes_buttonBox
	connect ( errcodes_buttonBox, SIGNAL ( clicked(QAbstractButton*) ),this,SLOT ( errcodes_buttonBox_clicked(QAbstractButton*)));
	
	//test button - remove later
	connect ( test_pushButton, SIGNAL ( clicked() ), this, SLOT ( test_clicked() ) );
}


MarmotErrCodes::~MarmotErrCodes()
{
	qDebug("DEBUG: MarmotErrCodes::~MarmotErrCodes() called\n");
}

void MarmotErrCodes::setGroupBoxBackgroundColor(QGroupBox *box,QColor color)
{
	//QPalette paldarkGreen(QColor(Qt::darkGreen));
	QPalette boxcolor(color);
	box->setAutoFillBackground(true);
	box->setPalette(boxcolor);
}

void MarmotErrCodes::disable_clicked()
{
	//qDebug("DEBUG: MarmotErrCodes::disable() sender=%s\n",qPrintable(sender()->objectName()));
	//qDebug("DEBUG: MarmotErrCodes::disable() sender->parent=%s\n",qPrintable(sender()->parent()->objectName()));
	//qDebug("DEBUG: MarmotErrCodes::disable() sender->grandparent=%s\n",qPrintable(sender()->parent()->parent()->objectName()));
	setGroupBoxBackgroundColor((QGroupBox*)(sender()->parent()->parent()),Qt::darkGray);
	QList<QCheckBox *> allCheckBoxes = sender()->parent()->parent()->findChildren<QCheckBox *>();
	for(int i=0;i<allCheckBoxes.size();i++)
	{
		allCheckBoxes[i]->setDisabled(true);
	}
	qDebug("DEBUG: setting status (%s,%i)\n",qPrintable(sender()->parent()->objectName()),0);
	setStatus(sender()->parent()->objectName(),0);
}

void MarmotErrCodes::enable_clicked()
{
	//setGroupBoxBackgroundColor(comm_groupBox,Qt::darkGreen);
	setGroupBoxBackgroundColor((QGroupBox*)(sender()->parent()->parent()),Qt::darkGreen);
	QList<QCheckBox *> allCheckBoxes = sender()->parent()->parent()->findChildren<QCheckBox *>();
	for(int i=0;i<allCheckBoxes.size();i++)
	{
	       allCheckBoxes[i]->setDisabled(true);
	}
	qDebug("DEBUG: setting status (%s,%i)\n",qPrintable(sender()->parent()->objectName()),1);
	setStatus(sender()->parent()->objectName(),1);
	//comm_null_checkBox->setDisabled(true);
}

void MarmotErrCodes::selection_clicked()
{
	setGroupBoxBackgroundColor((QGroupBox*)(sender()->parent()->parent()),Qt::darkYellow);
	QList<QCheckBox *> allCheckBoxes = sender()->parent()->parent()->findChildren<QCheckBox *>();
	for(int i=0;i<allCheckBoxes.size();i++)
	{
	       allCheckBoxes[i]->setDisabled(false);
	}
	qDebug("DEBUG: setting status (%s,%i)\n",qPrintable(sender()->parent()->objectName()),2);
	setStatus(sender()->parent()->objectName(),2);
}

void MarmotErrCodes::errcodes_buttonBox_clicked(QAbstractButton *button)
{
	qDebug("DEBUG: MarmotErrCodes::errcodes_buttonBox_clicked: Button: %s\n",qPrintable(button->text()));
	return;
}

void MarmotErrCodes::test_clicked()
{
	int num_groupboxes;
	int num_errcodes;
	qDebug("DEBUG: MarmotErrCodes::test_clicked() called\n");
	//initialize test_errcodes
	for(int i=0;i<181;i++)
	{
		test_errcodes[0][i]=false;
		test_errcodes[1][i]=false;
	}
	num_errcodes=0;
	QList<QGroupBox *> allgroupBoxes = selection_tabWidget->findChildren<QGroupBox *>();
	num_groupboxes=allgroupBoxes.size();
	qDebug("DEBUG: %i groupBoxes\n",num_groupboxes);
	for(int i=0;i<num_groupboxes;i++)
	{
		int state;//0==disable,1==enable,2==selection
		QList<QCheckBox *> allcheckBoxes=allgroupBoxes[i]->findChildren<QCheckBox *>();
		QFrame *frame=allgroupBoxes[i]->findChild<QFrame *>();
		if(frame)
		{
			qDebug("DEBUG: frame found\n");
			QList<QRadioButton *> allradioButtons=frame->findChildren<QRadioButton *>();
			for(int i=0;i<allradioButtons.size();i++)
			{
				if(allradioButtons[i]->isChecked())
				{
					qDebug("DEBUG: checked: %s",qPrintable(allradioButtons[i]->text()));
					if(!allradioButtons[i]->text().compare("enable"))state=1;
					if(!allradioButtons[i]->text().compare("disable"))state=0;
					if(!allradioButtons[i]->text().compare("selection"))state=2;
					qDebug("DEBUG: state: %i\n",state);
				}
			}
		}
		else
		{
			qDebug("DEBUG: error: no frame inside the group box\n");
		}
		qDebug("DEBUG: groupBox %i (%s): %i checkBoxes\n",i,qPrintable(allgroupBoxes[i]->objectName()),allcheckBoxes.size());
		num_errcodes+=allcheckBoxes.size();
		for(int i=0;i<allcheckBoxes.size();i++)
		{
			int errcode;
			bool checked;
			qDebug("DEBUG: checkBox: %s ",qPrintable(allcheckBoxes[i]->objectName()));
			errcode=(allcheckBoxes[i]->objectName().mid(1,3)).toInt();
			checked=allcheckBoxes[i]->isChecked();
			qDebug("DEBUG: errcode=%i\n",errcode);
			switch(state)
			{
				case 0:
					test_errcodes[1][errcode]=false;
					break;
				case 1:
					test_errcodes[1][errcode]=true;
					break;
				case 2:
					test_errcodes[1][errcode]=checked?true:false;
					break;
				default:
					qDebug("status not valid\n");
			}
			test_errcodes[0][errcode]=checked?true:false;

		}
	}

	qDebug("DEBUG: num_errcodes: %i ",num_errcodes);
	for(int i=0;i<181;i++)
	{
		//cerr << "["<<i<<" "<<test_errcodes[0][i]<<" "<<test_errcodes[1][i]<<"] ";
		qDebug("[%d %d %d] ",i, (int)test_errcodes[0][i], (int)test_errcodes[1][i]);
	}
	//cerr<<endl;
	m_Conf->setErrCodes(test_errcodes[0]);
	m_Conf->setEffectiveErrCodes(test_errcodes[1]);
	return;
}

void MarmotErrCodes::resetSelection(int mode)
{
	qDebug("DEBUG: MarmotErrCodes:: resetSelection(%i) called\n", mode);
	switch(mode)
	{
		case 1:		//enable
			//errors
			comm_err_enable_radioButton->click();
			buffer_err_enable_radioButton->click();
			rank_err_enable_radioButton->click();
			type_err_enable_radioButton->click();
			request_err_enable_radioButton->click();
			io_err_enable_radioButton->click();
			misc_err_enable_radioButton->click();
			//warnings
			comm_warn_enable_radioButton->click();
			rank_warn_enable_radioButton->click();
			request_warn_enable_radioButton->click();
			type_warn_enable_radioButton->click();
			thread_warn_enable_radioButton->click();
			misc_warn_enable_radioButton->click();
			//notes
			type_note_enable_radioButton->click();
			misc_note_enable_radioButton->click();
			break;
		case 0:		//disable
			//TODO
			break;
		case 2:		//selection
			//TODO
			break;
		default:
			qDebug("DEBUG: MarmotErrCodes::resetSelection: mode %i not valid\n",mode);
	}

	return;
}

void MarmotErrCodes::getSelectionFromConf()
{
	m_Conf->getErrCodes(test_errcodes[0]);
	for(int i=0;i<181;i++)			//TODO: avoid this hardcoding
	{
		setErrCodeStatus(i,test_errcodes[0][i]);
		qDebug("[%i %i]  ",i,test_errcodes[0][i]?1:0);
	}
	qDebug("DEBUG: getStatusCommErr=%i\n",m_Conf->getStatusCommErr());
	switch(m_Conf->getStatusCommErr())
	{
		case 0: comm_err_disable_radioButton->click();break;
		case 1: comm_err_enable_radioButton->click();break;
		case 2: comm_err_selection_radioButton->click();break;
	}
	qDebug("DEBUG: getStatusBufferErr=%i\n",m_Conf->getStatusBufferErr());
	switch(m_Conf->getStatusBufferErr())
	{
		case 0: buffer_err_disable_radioButton->click();break;
		case 1: buffer_err_enable_radioButton->click();break;
		case 2: buffer_err_selection_radioButton->click();break;
	}
	qDebug("DEBUG: getStatusRankErr=%i\n",m_Conf->getStatusRankErr());
	switch(m_Conf->getStatusRankErr())
	{
		case 0: rank_err_disable_radioButton->click();break;
		case 1: rank_err_enable_radioButton->click();break;
		case 2: rank_err_selection_radioButton->click();break;
	}
	qDebug("DEBUG: getStatusTypeErr=%i\n",m_Conf->getStatusTypeErr());
	switch(m_Conf->getStatusTypeErr())
	{
		case 0: type_err_disable_radioButton->click();break;
		case 1: type_err_enable_radioButton->click();break;
		case 2: type_err_selection_radioButton->click();break;
	}
	qDebug("DEBUG: getStatusRequestErr=%i\n",m_Conf->getStatusRequestErr());
	switch(m_Conf->getStatusRequestErr())
	{
		case 0: request_err_disable_radioButton->click();break;
		case 1: request_err_enable_radioButton->click();break;
		case 2: request_err_selection_radioButton->click();break;
	}
	qDebug("DEBUG: getStatusIOErr=%i\n",m_Conf->getStatusIOErr());
	switch(m_Conf->getStatusIOErr())
	{
		case 0: io_err_disable_radioButton->click();break;
		case 1: io_err_enable_radioButton->click();break;
		case 2: io_err_selection_radioButton->click();break;
	}
	qDebug("DEBUG: getStatusMiscErr=%i\n",m_Conf->getStatusMiscErr());
	switch(m_Conf->getStatusMiscErr())
	{
		case 0: misc_err_disable_radioButton->click();break;
		case 1: misc_err_enable_radioButton->click();break;
		case 2: misc_err_selection_radioButton->click();break;
	}
	qDebug("DEBUG: getStatusCommWarn=%i\n",m_Conf->getStatusCommWarn());
	switch(m_Conf->getStatusCommWarn())
	{
		case 0: comm_warn_disable_radioButton->click();break;
		case 1: comm_warn_enable_radioButton->click();break;
		case 2: comm_warn_selection_radioButton->click();break;
	}
	qDebug("DEBUG: getStatusRankWarn=%i\n",m_Conf->getStatusRankWarn());
	switch(m_Conf->getStatusRankWarn())
	{
		case 0: rank_warn_disable_radioButton->click();break;
		case 1: rank_warn_enable_radioButton->click();break;
		case 2: rank_warn_selection_radioButton->click();break;
	}
	qDebug("DEBUG: getStatusRequestWarn=%i\n",m_Conf->getStatusRequestWarn());
	switch(m_Conf->getStatusRequestWarn())
	{
		case 0: request_warn_disable_radioButton->click();break;
		case 1: request_warn_enable_radioButton->click();break;
		case 2: request_warn_selection_radioButton->click();break;
	}
	qDebug("DEBUG: getStatusTypeWarn=%i\n",m_Conf->getStatusTypeWarn());
	switch(m_Conf->getStatusTypeWarn())
	{
		case 0: type_warn_disable_radioButton->click();break;
		case 1: type_warn_enable_radioButton->click();break;
		case 2: type_warn_selection_radioButton->click();break;
	}
	qDebug("DEBUG: getStatusThreadWarn=%i\n",m_Conf->getStatusThreadWarn());
	switch(m_Conf->getStatusThreadWarn())
	{
		case 0: thread_warn_disable_radioButton->click();break;
		case 1: thread_warn_enable_radioButton->click();break;
		case 2: thread_warn_selection_radioButton->click();break;
	}
	qDebug("DEBUG: getStatusMiscWarn=%i\n",m_Conf->getStatusMiscWarn());
	switch(m_Conf->getStatusMiscWarn())
	{
		case 0: misc_warn_disable_radioButton->click();break;
		case 1: misc_warn_enable_radioButton->click();break;
		case 2: misc_warn_selection_radioButton->click();break;
	}
	qDebug("DEBUG: getStatusTypeNote=%i\n",m_Conf->getStatusTypeNote());
	switch(m_Conf->getStatusTypeNote())
	{
		case 0: type_note_disable_radioButton->click();break;
		case 1: type_note_enable_radioButton->click();break;
		case 2: type_note_selection_radioButton->click();break;
	}
	qDebug("DEBUG: getStatusMiscNote=%i\n",m_Conf->getStatusMiscNote());
	switch(m_Conf->getStatusMiscNote())
	{
		case 0: misc_note_disable_radioButton->click();break;
		case 1: misc_note_enable_radioButton->click();break;
		case 2: misc_note_selection_radioButton->click();break;
	}
	return;
}

int MarmotErrCodes::setErrCodeStatus(int code,bool enable)
{
	int num_groupboxes;
	//int num_errcodes;
	//qDebug("DEBUG: MarmotErrCodes::setErrCodeStatus (%i,%i) called\n",code,enable?1:0);
	//num_errcodes=0;
	QList<QGroupBox *> allgroupBoxes = selection_tabWidget->findChildren<QGroupBox *>();
	num_groupboxes=allgroupBoxes.size();
	//qDebug("DEBUG: %i groupBoxes\n",num_groupboxes);
	for(int i=0;i<num_groupboxes;i++)
	{
		int state;//0==disable,1==enable,2==selection
		QList<QCheckBox *> allcheckBoxes=allgroupBoxes[i]->findChildren<QCheckBox *>();
		//qDebug("DEBUG: groupBox %i (%s): %i checkBoxes\n",i,qPrintable(allgroupBoxes[i]->objectName()),allcheckBoxes.size());
		//num_errcodes+=allcheckBoxes.size();
		for(int i=0;i<allcheckBoxes.size();i++)
		{
			int errcode;
			//bool checked;
			//qDebug("DEBUG: checkBox: %s ",qPrintable(allcheckBoxes[i]->objectName()));
			errcode=(allcheckBoxes[i]->objectName().mid(1,3)).toInt();
			if(code==errcode)
			{
				if(enable)
				{
					allcheckBoxes[i]->setChecked(true);
				}
				else
				{
					allcheckBoxes[i]->setChecked(false);
				}
				return 0;
			}
		}
	}

	return 1;
}

void MarmotErrCodes::setStatus(QString frame_name, int status)
{
	if(!frame_name.compare("comm_err_frame")) m_Conf->setStatusCommErr(status);
	if(!frame_name.compare("buffer_err_frame")) m_Conf->setStatusBufferErr(status);
	if(!frame_name.compare("rank_err_frame")) m_Conf->setStatusRankErr(status);
	if(!frame_name.compare("type_err_frame")) m_Conf->setStatusTypeErr(status);
	if(!frame_name.compare("request_err_frame")) m_Conf->setStatusRequestErr(status);
	if(!frame_name.compare("io_err_frame")) m_Conf->setStatusIOErr(status);
	if(!frame_name.compare("misc_err_frame")) m_Conf->setStatusMiscErr(status);
	if(!frame_name.compare("comm_warn_frame")) m_Conf->setStatusCommWarn(status);
	if(!frame_name.compare("rank_warn_frame")) m_Conf->setStatusRankWarn(status);
	if(!frame_name.compare("request_warn_frame")) m_Conf->setStatusRequestWarn(status);
	if(!frame_name.compare("type_warn_frame")) m_Conf->setStatusTypeWarn(status);
	if(!frame_name.compare("thread_warn_frame")) m_Conf->setStatusThreadWarn(status);
	if(!frame_name.compare("misc_warn_frame")) m_Conf->setStatusMiscWarn(status);
	if(!frame_name.compare("type_note_frame")) m_Conf->setStatusTypeNote(status);
	if(!frame_name.compare("misc_note_frame")) m_Conf->setStatusMiscNote(status);
	return;
}
