/*
 * Copyright (c) 2002-2008 High Performance Computing Center Stuttgart,
 *                         University of Stuttgart.  All rights reserved.
 * Copyright (c) 2006-2008 The Center for Information Services and HPC
 *                         Technical University of Dresden.
 *                         All rights reserved.
 *
 * $COPYRIGHT$
 *
 * Additional copyrights may follow
 *
 * $HEADER$
 */
#ifndef MARMOTERRCODES_H
#define MARMOTERRCODES_H

#include <QtGui>
#include "ui_marmoterrcodes.h"
#include "MarmotGUIConfiguration.h"
#include <QDialog>
#include <QRadioButton>


/*!
 this is the main class of the MarmotGUI
 */
class MarmotErrCodes : public QDialog, private Ui::MarmotErrCodesDlg
{
	    Q_OBJECT
		     
	public:
		MarmotErrCodes(MarmotGUIConfiguration *conf,QWidget *parent = 0);
	        MarmotErrCodes(QWidget *parent = 0);
		~MarmotErrCodes(); 
	private:
		MarmotGUIConfiguration *m_Conf;
		void setGroupBoxBackgroundColor(QGroupBox *box,QColor color);
		void setupConnections();
		void resetSelection(int mode);	//reset the err code selection (1==enable, 0==disable, 2==selection)
		bool test_errcodes[2][181];	//remove later	
		void setStatus(QString frame_name, int status);
			 
	public slots:
	private slots:
		void disable_clicked();
		void enable_clicked();
		void selection_clicked();
		void errcodes_buttonBox_clicked(QAbstractButton *button);
		void test_clicked();	//remove later
		void getSelectionFromConf();
		int setErrCodeStatus(int code,bool enable);
};
 
 
#endif
