package de.hlrs.marmoclipse.log.ui;

import org.eclipse.jface.viewers.CellEditor;
import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Link;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.program.Program;;

public class ReferenceCellEditor extends CellEditor {
	private static final String LINK_TOOLTIP = "Click to open the reference page in extenal browser";
	private Link link;

	public ReferenceCellEditor(Composite parent) {
		super(parent);
	}

	public ReferenceCellEditor(Composite parent, int style) {
		super(parent, style);
	}

	@Override
	protected Control createControl(Composite parent) {
		link = new Link(parent, getStyle());
		link.setBackground(parent.getBackground());
		link.setToolTipText(LINK_TOOLTIP);
		link.addListener(SWT.Selection, new Listener() {
			public void handleEvent(Event event) {
				Program.launch(event.text);
			}
		});
		return link;
	}

	@Override
	protected Object doGetValue() {
		String str = link.getText();
		return str.substring(3, str.length()-4);
	}

	@Override
	protected void doSetFocus() {
		link.setFocus();
	}

	@Override
	protected void doSetValue(Object value) {
		link.setText("<a>" + String.valueOf(value) + "</a>");
	}

}
