/**
 *  @file
 *
 *  This program is a very simple MPI program to verify that the 
 *  library works correctly.
 *
 *  It just calls 
 *  - MPI_Init
 *  - MPI_Finalize 
 *  - MPI_Comm_rank
 *  - MPI_Comm_size
 *  - MPI_Bcast
 *  - MPI_Barrier
 *
 *  @author Bettina Krammer, Katrin Bidmon, Matthias Mueller
 *
 *  $Id: bcast.c 319 2004-08-16 11:25:02Z rusbetti $  
 */

#include <stdio.h>
#include <assert.h>
#include "mpi.h"

int main(int argc, char **argv)
{
    const int COUNT = 1;

    int size = -1;
    int rank = -1;
    int value = -1;
    int value2 = -1;

    MPI::Init(argc, argv);
    size=MPI::COMM_WORLD.Get_size();
    rank=MPI::COMM_WORLD.Get_rank();
    printf(" I am rank %d of %d PEs\n", rank, size);

    if (rank == 0)
    {
        /* going to be root */
        value = 37;
    }

    MPI::COMM_WORLD.Barrier();

    if (rank == 0)
    {
	    MPI::COMM_WORLD.Bcast(&value, COUNT, MPI::INT, 0);
    }

    if (rank != 0)
    {
	    MPI::COMM_WORLD.Bcast(&value2, COUNT, MPI::INT, 0);
        assert(value2 == 37);
    }

    MPI::Finalize();

    return 0;
}
