#!/bin/sh
echo "Building the Marmot CPP examples"
MARMOTCXX=`which marmotcxx`
if [ "$MARMOTCXX" = "" ]
then
	echo "No marmotcxx in PATH. Exiting"
	exit 1
fi
echo "marmotcxx is $MARMOTCXX"
for e in `ls *.cc`;
do
	EXE_NAME=`echo $e|sed -e "s/\.cc//"`
	EXE_NAME=${EXE_NAME}_m
	echo -n "Building $EXE_NAME ..."
	marmotcxx -o $EXE_NAME $e
	if [ $? -ne 0 ]
	then
		echo "Could not build $EXE_NAME. Exiting"
		exit 2
	fi
done

