/**
 *  @file
 *
 *  This program is a very simple MPI program to verify that the 
 *  library works correctly.
 *  
 *  It just calls 
 *  - MPI_Init
 *  - MPI_Finalize 
 *  - MPI_Comm_rank
 *  - MPI_Comm_size
 *  - MPI_Dims_create
 *  - MPI_Cart_create
 *
 *  @author Bettina Krammer, Katrin Bidmon, Matthias Mueller
 *
 *  $Id: dims-create.c 319 2004-08-16 11:25:02Z rusbetti $  
 */


#include <stdio.h>
#include <assert.h>
#include "mpi.h"

int main(int argc, char **argv)
{
    int size = -1;
    int rank = -1;
    int ndims = 2;
    int dims[2] = { 2, 0 };
    bool periods[2] = { 0, 0 };
    MPI::Cartcomm comm_cart;

    printf("dim1=%d, dim2=%d \n", dims[0], dims[1]);
    MPI::Init(argc, argv);
    size=MPI::COMM_WORLD.Get_size();
    rank=MPI::COMM_WORLD.Get_rank();

    printf(" I am rank %d of %d PEs\n", rank, size);

    //MPI_Dims_create(size, ndims, dims);
    MPI::Compute_dims(size, ndims, dims);

    comm_cart=MPI::COMM_WORLD.Create_cart(2, dims, periods, 0);

    MPI::Finalize();

    return 0;
}
