/**
 *  @file
 *
 *  This program is a very simple MPI program to verify that the 
 *  library works correctly.
 *
 *  It just calls 
 *  - MPI_Init
 *  - MPI_Finalize 
 *  - MPI_Comm_rank
 *  - MPI_Comm_size
 *  - MPI_Barrier
 *  - MPI_Gather
 *
 *  @author Bettina Krammer, Katrin Bidmon, Matthias Mueller
 *
 *  $Id: gather.c 319 2004-08-16 11:25:02Z rusbetti $  
 */

#include <stdio.h>
#include <assert.h>
#include <stdlib.h>

#include <mpi.h>

int main(int argc, char **argv)
{
    const int COUNT = 1;

    int size = -1;
    int rank = -1;
    int sendbuf = -1;
    int *recvbuf = 0;

    MPI::Init(argc, argv);
    size=MPI::COMM_WORLD.Get_size();
    rank=MPI::COMM_WORLD.Get_rank();
    printf(" I am rank %d of %d PEs\n", rank, size);

    recvbuf = (int *) malloc(size * sizeof(MPI::INT));
    MPI::COMM_WORLD.Barrier();

    if (rank == 0)
    {
	MPI::COMM_WORLD.Gather(&sendbuf, COUNT, MPI::INT, recvbuf, COUNT, MPI::INT, 0);
    }

    /* why assert(..)? */
    /*assert(*recvbuf==37); */

    if (rank != 0)
    {
        sendbuf = 37;
	MPI::COMM_WORLD.Gather(&sendbuf, COUNT, MPI::INT, recvbuf, COUNT, MPI::INT, 0);
    }

    free(recvbuf);

    MPI::Finalize();

    return 0;
}
