/**
 *  @file
 *
 *  This program is a very simple MPI program to verify that the 
 *  library works correctly.
 *  
 *  It just calls 
 *  - MPI_Init
 *  - MPI_Finalize 
 *  - MPI_Comm_rank
 *  - MPI_Comm_size
 *  - MPI_Comm_group
 *  - MPI_Group_range_incl
 *  - MPI_Group_range_excl
 *  - MPI_Group_free
 *
 *  @author Bettina Krammer, Katrin Bidmon, Matthias Mueller
 *
 *  $Id: group-ranges.c 319 2004-08-16 11:25:02Z rusbetti $  
 */


#include <stdio.h>
#include <assert.h>
#include "mpi.h"

const int NUM = 3;

int main(int argc, char **argv)
{
    int size = -1;
    int rank = -1;
    int ranges[NUM][3];
    int ranges1[NUM][3];
    int i = 0;

    MPI::Group worldgroup;
    MPI::Group newgroup;

    printf("This programm works correctly for less than 10 nodes. \n");
    printf("With 10 nodes or more we try to exclude some ranks twice. \n");
    MPI::Init(argc, argv);
    size=MPI::COMM_WORLD.Get_size();
    rank=MPI::COMM_WORLD.Get_rank();

    for (i = 0; i <= NUM - 1; i++)
    {
        /* ranges for range_incl, don't have to be distinct */
        ranges[i][0] = 0;
        ranges[i][1] = size - 1;
        ranges[i][2] = (i + 2);
        /* ranges for range_excl, are erroneous if not distinct */
        ranges1[i][0] = 0 + i;
        ranges1[i][1] = size - 1;
        ranges1[i][2] = (i + 3);

    }

    printf(" I am rank %d of %d PEs\n", rank, size);

    worldgroup=MPI::COMM_WORLD.Get_group();
    newgroup=worldgroup.Range_incl(NUM, ranges);
    newgroup.Free();
    newgroup=worldgroup.Range_incl(NUM, ranges1);
    newgroup.Free();

    MPI::Finalize();

    return 1;
}
