/**
 *  @file
 *
 *  This program is a very simple MPI program to verify that the 
 *  library works correctly.
 *
 *  It just calls 
 *  - MPI_Init
 *  - MPI_Finalize 
 *  - MPI_Comm_rank
 *  - MPI_Comm_size
 *  - MPI_Isend
 *  - MPI_Testany
 *  - MPI_Recv
 *
 *  @author Bettina Krammer, Katrin Bidmon, Matthias Mueller
 *
 *  $Id: testany-noreq.c 319 2004-08-16 11:25:02Z rusbetti $  
 */

 /*
  ** We have no requests in the array 
  */

#include <stdio.h>
#include <assert.h>
/* #include <time.h>
 * use instead
 */
#include <unistd.h>
#include "mpi.h"

int main(int argc, char **argv)
{
    const int COUNT = 1;
    const int MSG_TAG = 17;

    int size = -1;
    int rank = -1;
    int value = -1;
    int value2 = -1;
    int index = -1;
    int flag = 0;

    MPI::Status status;
    MPI::Status status_arr[1];
    MPI::Request request;
    MPI::Request request_arr[1];

    printf("We call Testany with empty request_arr, count=0.\n");
    MPI::Init(argc, argv);
    size=MPI::COMM_WORLD.Get_size();
    rank=MPI::COMM_WORLD.Get_rank();
    printf(" I am rank %d of %d PEs\n", rank, size);

    if (rank == 0)
    {
        /* going to receive message */
	    MPI::COMM_WORLD.Recv(&value2, COUNT, MPI::INT, 1, MSG_TAG, status);
        assert(value2 == 19);
    }

    if (rank == 1)
    {
        /* going to send message */
        value = 19;
        request=MPI::COMM_WORLD.Isend(&value, COUNT, MPI::INT, 0, MSG_TAG);
        request.Wait(status);
        sleep(1);
        flag=MPI::Request::Testany(0, request_arr, index, *status_arr);
        if (index != MPI_UNDEFINED)
            printf(" index(of now freed request)= %d \n", index);
    }

    MPI::Finalize();

    return 1;
}
