#!/bin/sh
echo "Building the Marmot Fortran examples"
MARMOTFC=`which marmotf90`
if [ "$MARMOTFC" = "" ]
then
	echo "No marmotf90 in PATH. Exiting"
	exit 1
fi
echo "marmotf90 is $MARMOTFC"
for e in `ls *.f`;
do
	EXE_NAME=`echo $e|sed -e "s/\.f//"`
	EXE_NAME=${EXE_NAME}_m
	echo -n "Building $EXE_NAME ..."
	marmotf90 -o $EXE_NAME $e
	if [ $? -ne 0 ]
	then
		echo "Could not build $EXE_NAME. Exiting"
		exit 2
	fi
done

