#! /bin/bash

#Marmot installation script for SX6 (asama.hww.de)
#14/06/2007

# documentation disabled (no pdflatex)
# tests disabled 

function build_sx6
{
	#We use the SX compiler from NEC
	#MPI Library
	module list 
	export SX_BASE_CROSS=/SX6/opt/crosskit/inst/
    export PATH=/SX6/usr/bin/:$PATH
    export SX_BASE_CPLUS=/SX6/opt/sxc++/inst
    export SX_BASE_F90=/SX6/opt/sxf90/inst
    export SX_BASE_MPI=/SX6/opt/mpisx/inst
    
    export CC="sxcc"
	export CXX="sxc++"
	export F77="sxf90"
	export export CPP="sxcc -E"
	export AR="sxar"
	export CXXFLAGS="-K exceptions"
    
	#configure marmot
	./configure --with-mpi-dir=/opt/NECmpi --disable-tests --disable-doc --prefix=$INSTALL_DIR --host=sx6-nec-superux
	#This alias doesn't seem to work; why?
	#Workaround: Manually replace "ranlib" with "sxar -s" in the Makefiles
	#alias ranlib='sxar -s'
	make 2>&1 |tee make_${DATE}.log
	#( cd TEST_C ; make 2>&1|tee make_${DATE}.log )
	make install
}

function prepare
{
	set -x
	make clean
	aclocal -I config
	autoheader
	automake 
	autoconf -Wall
	DATE=`date +%Y%m%d_%H%M`
	INSTALL_DIR=$HOME/parma/marmot_build_${1}_$DATE
	echo "Marmot will be installed in $INSTALL_DIR"
	case "$1" in 
		sx6)
		build_sx6
		;;
		*)
		;;
	esac
}

case "$1" in

	sx6)

		echo "Building marmot (cross compile for SX6)"
		prepare $1
		;;

	*)
		echo "Usage: $0 {sx6}"
		;;

esac



