#! /bin/bash

#Marmot installation script for IA64 (ia64.hww.de)
#12/06/2007

# documentation disabled (no pdflatex)
# tests disabled (make trys to build the tests before the library is built?)
# However the tests in the TEST_C folder are built "manually"


function build_intel
{
	#Shall we perform module switching from within this script?
	#We use the Intel Compiler	 
	#module switch intel intel/compiler9.1
	#and the appropriate MPI library
	#module switch mpich mpich/mpich-1.2.7..15-Myrinet-Intel9.1
	#show loaded modules
	module list
	#configure marmot
	./configure --with-mpi-dir=/opt/mpi/mpich-1.2.7..15-Myrinet-Intel9.1 --disable-tests --disable-doc --prefix=$INSTALL_DIR --enable-myrinet --with-myrinet-dir=/opt/Myricom/2.0.10 --enable-mpichp4 CXXFLAGS="-g -Wall" CFLAGS="-g -Wall" FFLAGS="-g -Wall" CXX="icpc" CC="icc" CPP="icc -E" F77="ifort" 
	make 2>&1 |tee make_${DATE}.log
	( cd TEST_C ; make 2>&1|tee make_${DATE}.log )
	make install
}

function build_gcc
{
	#We use the GCC Compiler
	#the Myrinet library is compiled with GCC 3.2.3, but GCC 3.2.3 does not seem to be installed
	#instead we are using the newest version available
	#module switch gcc gcc//3.3.1
	#MPI Library
	#module switch mpich mpich/mpich-1.2.5..12-Myrinet-gcc
	module list 
	#as GCC is the default compiler, we can simply unset the environment variables
	unset CXX
	unset CC
	unset CPP
	unset F77
	#configure marmot
	./configure --with-mpi-dir=/opt/mpi/mpich-1.2.5..12-Myrinet-gcc --disable-tests --disable-doc --prefix=$INSTALL_DIR --enable-myrinet --with-myrinet-dir=/opt/Myricom/2.0.10 --enable-mpichp4 CXXFLAGS="-g -Wall " CFLAGS="-g -Wall " FFLAGS="-g -Wall "  
	make 2>&1 |tee make_${DATE}.log
	( cd TEST_C ; make 2>&1|tee make_${DATE}.log )
	make install
}

function prepare
{
	set -x
	make clean
	aclocal -I config
	autoheader
	automake 
	autoconf -Wall
	DATE=`date +%Y%m%d_%H%M`
	INSTALL_DIR=$HOME/marmot_build_${1}_$DATE
	echo "Marmot will be installed in $INSTALL_DIR"
	case "$1" in 
		intel)
		build_intel
		;;
		gcc)
		build_gcc
		;;
		*)
		;;
	esac
}

case "$1" in

	intel)

		echo "Building marmot with Intel Compiler"
		prepare $1
		;;

	gcc)

		echo "Building marmot with GCC Compiler"
		prepare $1
		;;

	*)
		echo "Usage: $0 {intel|gcc}"
		;;

esac

###############################################################################
#						Building TEST_C/deadlock1.c							  #	
###############################################################################
#
#Intel 9.1
#mpich-1.2.7..15-Myrinet-Intel9.1
#
#
#$mpicc -show deadlock1.c
#icc -DUSE_STDARG -DHAVE_STDLIB_H=1 -DHAVE_STRING_H=1 -DHAVE_UNISTD_H=1 -DHAVE_STDARG_H=1 -DUSE_STDARG=1 -DMALLOC_RET_VOID=1 -c deadlock1.c -I/opt/mpi/mpich-1.2.7..15-Myrinet-Intel9.1/include
#icc -DUSE_STDARG -DHAVE_STDLIB_H=1 -DHAVE_STRING_H=1 -DHAVE_UNISTD_H=1 -DHAVE_STDARG_H=1 -DUSE_STDARG=1 -DMALLOC_RET_VOID=1 -Wl,-rpath -Wl,/opt/mpi/mpich-1.2.7..15-Myrinet-Intel9.1/lib/shared -L/opt/mpi/mpich-1.2.7..15-Myrinet-Intel9.1/lib/shared -L/opt/mpi/mpich-1.2.7..15-Myrinet-Intel9.1/lib deadlock1.o -lpmpich -lmpich -lpmpich -lmpich -Wl,-rpath,/opt/Myricom/2.0.10/lib/ -L/opt/Myricom/2.0.10/lib/ -lgm -lpthread -lifcore -lpthread -lrt
#
#$/ia64/HLRS/hlrs/hpchimml/marmot_build_intel_20070612_1440/bin/marmotcc -show deadlock1.c
#
#mpicc -show deadlock1.c -L/ia64/HLRS/hlrs/hpchimml/marmot_build_intel_20070612_1440/lib -lmarmot-profile -lmarmot-core -L/opt/mpi/mpich-1.2.7..15-Myrinet-Intel9.1/lib -lpmpich -lmpich -lpmpich -L/opt/Myricom/2.0.10/lib -lgm -lpthread -L/usr/lib -lstdc++ -I/ia64/HLRS/hlrs/hpchimml/marmot_build_intel_20070612_1440/include
#
#icc -DUSE_STDARG -DHAVE_STDLIB_H=1 -DHAVE_STRING_H=1 -DHAVE_UNISTD_H=1 -DHAVE_STDARG_H=1 -DUSE_STDARG=1 -DMALLOC_RET_VOID=1 -c deadlock1.c -L/ia64/HLRS/hlrs/hpchimml/marmot_build_intel_20070612_1440/lib -L/opt/mpi/mpich-1.2.7..15-Myrinet-Intel9.1/lib -L/opt/Myricom/2.0.10/lib -L/usr/lib -I/ia64/HLRS/hlrs/hpchimml/marmot_build_intel_20070612_1440/include -I/opt/mpi/mpich-1.2.7..15-Myrinet-Intel9.1/include
#icc -DUSE_STDARG -DHAVE_STDLIB_H=1 -DHAVE_STRING_H=1 -DHAVE_UNISTD_H=1 -DHAVE_STDARG_H=1 -DUSE_STDARG=1 -DMALLOC_RET_VOID=1 -Wl,-rpath -Wl,/opt/mpi/mpich-1.2.7..15-Myrinet-Intel9.1/lib/shared -L/opt/mpi/mpich-1.2.7..15-Myrinet-Intel9.1/lib/shared -L/opt/mpi/mpich-1.2.7..15-Myrinet-Intel9.1/lib deadlock1.o -L/ia64/HLRS/hlrs/hpchimml/marmot_build_intel_20070612_1440/lib -lmarmot-profile -lmarmot-core -L/opt/mpi/mpich-1.2.7..15-Myrinet-Intel9.1/lib -lpmpich -lmpich -lpmpich -L/opt/Myricom/2.0.10/lib -lgm -lpthread -L/usr/lib -lstdc++ -I/ia64/HLRS/hlrs/hpchimml/marmot_build_intel_20070612_1440/include -lpmpich -lmpich -lpmpich -lmpich -Wl,-rpath,/opt/Myricom/2.0.10/lib/ -L/opt/Myricom/2.0.10/lib/ -lgm -lpthread -lifcore -lpthread -lrt
#
#$mpicc -o deadlock1_normal deadlock1.c -- OK
#
#$/ia64/HLRS/hlrs/hpchimml/marmot_build_intel_20070612_1440/bin/marmotcc deadlock1.c
#
#mpicc deadlock1.c -L/ia64/HLRS/hlrs/hpchimml/marmot_build_intel_20070612_1440/lib -lmarmot-profile -lmarmot-core -L/opt/mpi/mpich-1.2.7..15-Myrinet-Intel9.1/lib -lpmpich -lmpich -lpmpich -L/opt/Myricom/2.0.10/lib -lgm -lpthread -L/usr/lib -lstdc++ -I/ia64/HLRS/hlrs/hpchimml/marmot_build_intel_20070612_1440/include
#
#/ia64/HLRS/hlrs/hpchimml/marmot_build_intel_20070612_1440/lib/libmarmot-core.a(MPO_GroupConstructor.o)(.text+0x1282): In function `_ZN3MPO20MPO_Groupconstructor18checkPrerequisitesEv_LEH_1_83':
#: undefined reference to `__cxa_guard_acquire'
#/ia64/HLRS/hlrs/hpchimml/marmot_build_intel_20070612_1440/lib/libmarmot-core.a(MPO_GroupConstructor.o)(.text+0x12b2): In function `_ZN3MPO20MPO_Groupconstructor18checkPrerequisitesEv_LEH_1_83':
#: undefined reference to `__cxa_guard_release'
#/ia64/HLRS/hlrs/hpchimml/marmot_build_intel_20070612_1440/lib/libmarmot-core.a(MPO_GroupHandler.o)(.text+0x1282): In function `_ZN3MPO16MPO_Grouphandler18checkPrerequisitesEv_LEH_1_81':
#: undefined reference to `__cxa_guard_acquire'
#/ia64/HLRS/hlrs/hpchimml/marmot_build_intel_20070612_1440/lib/libmarmot-core.a(MPO_GroupHandler.o)(.text+0x12b2): In function `_ZN3MPO16MPO_Grouphandler18checkPrerequisitesEv_LEH_1_81':
#: undefined reference to `__cxa_guard_release'
#
#$/ia64/HLRS/hlrs/hpchimml/marmot_build_intel_20070612_1440/bin/marmotcc -o deadlock1_marmot deadlock1.c -lcxa
#
#mpicc -o deadlock1_marmot deadlock1.c -lcxa -L/ia64/HLRS/hlrs/hpchimml/marmot_build_intel_20070612_1440/lib -lmarmot-profile -lmarmot-core -L/opt/mpi/mpich-1.2.7..15-Myrinet-Intel9.1/lib -lpmpich -lmpich -lpmpich -L/opt/Myricom/2.0.10/lib -lgm -lpthread -L/usr/lib -lstdc++ -I/ia64/HLRS/hlrs/hpchimml/marmot_build_intel_20070612_1440/include  -- OK
#
#mpirun -np 2 -machinefile $PBS_NODEFILE ./deadlock1_normal
# I am rank 1 of 2 PEs
#  I am rank 0 of 2 PEs
#  1: signal 2 received, exiting..
#  1: Sent by user process, UID=0, PID=10699
#  0: signal 2 received, exiting..
#  0: Sent by user process, UID=0, PID=27833
#
#  OK
#
#$mpirun -np 3 -machinefile $PBS_NODEFILE ./deadlock1_marmot
# I am rank 0 of 2 PEs
#  I am rank 1 of 2 PEs
#  WARNING: all clients are pending! (Details see the LogFile)
#  1: signal 2 received, exiting..
#  1: Sent by user process, UID=0, PID=10703
#  2: signal 2 received, exiting..
#  2: Sent by user process, UID=0, PID=5667
#  0: signal 2 received, exiting..
#  0: Sent by user process, UID=0, PID=27873
#
# OK
###############################################################################
#
#GCC 3.2.2
#mpich/mpich-1.2.5..12-Myrinet-gcc
#
#
#$mpicc -show deadlock1.c
#cc -DUSE_STDARG -DHAVE_STDLIB_H=1 -DHAVE_STRING_H=1 -DHAVE_UNISTD_H=1 -DHAVE_STDARG_H=1 -DUSE_STDARG=1 -DMALLOC_RET_VOID=1 -c deadlock1.c -I/opt/mpi/mpich-1.2.5..12-Myrinet-gcc/include
#cc -DUSE_STDARG -DHAVE_STDLIB_H=1 -DHAVE_STRING_H=1 -DHAVE_UNISTD_H=1 -DHAVE_STDARG_H=1 -DUSE_STDARG=1 -DMALLOC_RET_VOID=1 -L/opt/mpi/mpich-1.2.5..12-Myrinet-gcc/lib deadlock1.o -lmpich -L/opt/Myricom/2.0.10/lib -lgm
#
#$/ia64/HLRS/hlrs/hpchimml/marmot_build_gcc_20070612_1527/bin/marmotcc -show deadlock1.c
#
#mpicc -show deadlock1.c -L/ia64/HLRS/hlrs/hpchimml/marmot_build_gcc_20070612_1527/lib -lmarmot-profile -lmarmot-core -L/opt/mpi/mpich-1.2.5..12-Myrinet-gcc/lib -lpmpich -lmpich -lpmpich -L/opt/Myricom/2.0.10/lib -lgm -lpthread -L/usr/lib -lstdc++ -I/ia64/HLRS/hlrs/hpchimml/marmot_build_gcc_20070612_1527/include
#
#cc -DUSE_STDARG -DHAVE_STDLIB_H=1 -DHAVE_STRING_H=1 -DHAVE_UNISTD_H=1 -DHAVE_STDARG_H=1 -DUSE_STDARG=1 -DMALLOC_RET_VOID=1 -c deadlock1.c -L/ia64/HLRS/hlrs/hpchimml/marmot_build_gcc_20070612_1527/lib -L/opt/mpi/mpich-1.2.5..12-Myrinet-gcc/lib -L/opt/Myricom/2.0.10/lib -L/usr/lib -I/ia64/HLRS/hlrs/hpchimml/marmot_build_gcc_20070612_1527/include -I/opt/mpi/mpich-1.2.5..12-Myrinet-gcc/include
#cc -DUSE_STDARG -DHAVE_STDLIB_H=1 -DHAVE_STRING_H=1 -DHAVE_UNISTD_H=1 -DHAVE_STDARG_H=1 -DUSE_STDARG=1 -DMALLOC_RET_VOID=1 -L/opt/mpi/mpich-1.2.5..12-Myrinet-gcc/lib deadlock1.o -L/ia64/HLRS/hlrs/hpchimml/marmot_build_gcc_20070612_1527/lib -lmarmot-profile -lmarmot-core -L/opt/mpi/mpich-1.2.5..12-Myrinet-gcc/lib -lpmpich -lmpich -lpmpich -L/opt/Myricom/2.0.10/lib -lgm -lpthread -L/usr/lib -lstdc++ -I/ia64/HLRS/hlrs/hpchimml/marmot_build_gcc_20070612_1527/include -lmpich -L/opt/Myricom/2.0.10/lib -lgm
#
#$mpicc -o deadlock1_normal deadlock1.c -- OK
#
#$/ia64/HLRS/hlrs/hpchimml/marmot_build_gcc_20070612_1527/bin/marmotcc -o deadlock1_marmot deadlock1.c
#
#mpicc -o deadlock1_marmot deadlock1.c -L/ia64/HLRS/hlrs/hpchimml/marmot_build_gcc_20070612_1527/lib -lmarmot-profile -lmarmot-core -L/opt/mpi/mpich-1.2.5..12-Myrinet-gcc/lib -lpmpich -lmpich -lpmpich -L/opt/Myricom/2.0.10/lib -lgm -lpthread -L/usr/lib -lstdc++ -I/ia64/HLRS/hlrs/hpchimml/marmot_build_gcc_20070612_1527/include -- OK
#
#$mpirun -np 2 -machinefile $PBS_NODEFILE ./deadlock1_normal
# I am rank 0 of 2 PEs
#  I am rank 1 of 2 PEs
#
#  OK
#
#$mpirun -np 3 -machinefile $PBS_NODEFILE ./deadlock1_marmot
# I am rank 0 of 2 PEs
#  I am rank 1 of 2 PEs
#  WARNING: all clients are pending! (Details see the LogFile)
#
# OK



