#! /bin/bash

#Marmot installation script for volvox (volvox.hww.de)
#18/06/2007

# documentation disabled (no pdflatex)
# tests disabled 


function build_intel
{
	#These are the loaded modules:
	#$module li
	#Currently Loaded Modulefiles:
  	#1) pbs/torque2.1.6                              5) oscar-modules/1.0.5
  	#2) pbs/maui-3.2.6p13                            6) gm/32bit-2.0.18
  	#3) compiler/32bit-intel8.1                      7) mpi/32bit/mpich-1.2.6..14-Myrinet-Intel8.1
  	#4) switcher/1.0.10
	#Shall we perform module switching from within this script?
	module list
	#configure marmot
	export CC="icc"
	export CXX="icpc"
	export F77="ifort"
	export CPP="icc -E"
	./configure --prefix=$INSTALL_DIR --disable-doc --disable-tests --enable-myrinet --with-myrinet-dir=/opt_X86_32/gm/2.0.18 --with-mpi-dir=/opt_X86_32/mpi/mpich-1.2.6..14-Myrinet-Intel8.1
	make 2>&1 |tee make_${DATE}.log
	#( cd TEST_C ; make 2>&1|tee make_${DATE}.log )
	make install
}

function build_gcc
{
	#These are the loaded modules:
	#$module li
	#Currently Loaded Modulefiles:
  	#1) pbs/torque2.1.6                         4) switcher/1.0.10                         7) mpi/32bit/mpich-1.2.6..14-Myrinet-gcc
  	#2) pbs/maui-3.2.6p13                       5) oscar-modules/1.0.5
  	#3) compiler/32bit-intel8.1                 6) gm/32bit-2.0.18
	#Shall we perform module switching from within this script?
	module list
	#configure marmot
	unset CC
	unset CXX
	unset F77
	unset CPP
	#it seems we need to build 32bit stuff
	export CCFLAGS="-m32"
	export CXXFLAGS="-m32"
	export FFLAGS="-m32"
	./configure --prefix=$INSTALL_DIR --disable-doc --disable-tests --enable-myrinet --with-myrinet-dir=/opt_X86_32/gm/2.0.18 --with-mpi-dir=/opt_X86_32/mpi/mpich-1.2.6..14-Myrinet-gcc
	make 2>&1 |tee make_${DATE}.log
	#( cd TEST_C ; make 2>&1|tee make_${DATE}.log )
	make install
}


function prepare
{
	set -x
	make clean
	aclocal -I config
	autoheader
	automake 
	autoconf -Wall
	DATE=`date +%Y%m%d_%H%M`
	INSTALL_DIR=$HOME/marmot_build_${1}_$DATE
	echo "Marmot will be installed in $INSTALL_DIR"
	case "$1" in 
		intel)
		build_intel
		;;
		gcc)
		build_gcc
		;;
		*)
		;;
	esac
}

case "$1" in

	intel)

		echo "Building marmot with Intel Compiler"
		prepare $1
		;;
		
	gcc)

		echo "Building marmot with GCC"
		prepare $1
		;;

	*)
		echo "Usage: $0 {intel|gcc}"
		;;

esac

###############################################################################
#						Building TEST_C/deadlock1.c							  #	
###############################################################################
#
#
#GCC 3.4.2
#mpich-1.2.6
#
#
#$mpicc -show deadlock1.c
#gcc -DUSE_STDARG -DHAVE_STDLIB_H=1 -DHAVE_STRING_H=1 -DHAVE_UNISTD_H=1 -DHAVE_STDARG_H=1 -DUSE_STDARG=1 -DMALLOC_RET_VOID=1 -c deadlock1.c -I/opt_X86_32/mpi/mpich-1.2.6..14-Myrinet-gcc/include
#gcc -DUSE_STDARG -DHAVE_STDLIB_H=1 -DHAVE_STRING_H=1 -DHAVE_UNISTD_H=1 -DHAVE_STDARG_H=1 -DUSE_STDARG=1 -DMALLOC_RET_VOID=1 -Wl,-rpath -Wl,/opt_X86_32/mpi/mpich-1.2.6..14-Myrinet-gcc/lib/shared -L/opt_X86_32/mpi/mpich-1.2.6..14-Myrinet-gcc/lib/shared -L/opt_X86_32/mpi/mpich-1.2.6..14-Myrinet-gcc/lib deadlock1.o -lmpich -Wl,-rpath,/opt_X86_32/gm/2.0.18/lib -L/opt_X86_32/gm/2.0.18/lib/ -lgm
#
#$/volvox/HLRS/hlrs/hpchimml/marmot_build_gcc_20070619_0910/bin/marmotcc -show deadlock1.c
#
#mpicc -show deadlock1.c -L/schrotti/HLRS/hlrs/hpchimml/marmot_build_gcc_20070619_0910/lib -lmarmot-profile -lmarmot-core -L/opt_X86_32/mpi/mpich-1.2.6..14-Myrinet-gcc/lib -lpmpich -lmpich -lpmpich -L/opt_X86_32/gm/2.0.18/lib -lgm -lpthread -L/usr/lib -lstdc++ -I/schrotti/HLRS/hlrs/hpchimml/marmot_build_gcc_20070619_0910/include
#
#gcc -DUSE_STDARG -DHAVE_STDLIB_H=1 -DHAVE_STRING_H=1 -DHAVE_UNISTD_H=1 -DHAVE_STDARG_H=1 -DUSE_STDARG=1 -DMALLOC_RET_VOID=1 -c deadlock1.c -L/schrotti/HLRS/hlrs/hpchimml/marmot_build_gcc_20070619_0910/lib -L/opt_X86_32/mpi/mpich-1.2.6..14-Myrinet-gcc/lib -L/opt_X86_32/gm/2.0.18/lib -L/usr/lib -I/schrotti/HLRS/hlrs/hpchimml/marmot_build_gcc_20070619_0910/include -I/opt_X86_32/mpi/mpich-1.2.6..14-Myrinet-gcc/include
#gcc -DUSE_STDARG -DHAVE_STDLIB_H=1 -DHAVE_STRING_H=1 -DHAVE_UNISTD_H=1 -DHAVE_STDARG_H=1 -DUSE_STDARG=1 -DMALLOC_RET_VOID=1 -Wl,-rpath -Wl,/opt_X86_32/mpi/mpich-1.2.6..14-Myrinet-gcc/lib/shared -L/opt_X86_32/mpi/mpich-1.2.6..14-Myrinet-gcc/lib/shared -L/opt_X86_32/mpi/mpich-1.2.6..14-Myrinet-gcc/lib deadlock1.o -L/schrotti/HLRS/hlrs/hpchimml/marmot_build_gcc_20070619_0910/lib -lmarmot-profile -lmarmot-core -L/opt_X86_32/mpi/mpich-1.2.6..14-Myrinet-gcc/lib -lpmpich -lmpich -lpmpich -L/opt_X86_32/gm/2.0.18/lib -lgm -lpthread -L/usr/lib -lstdc++ -I/schrotti/HLRS/hlrs/hpchimml/marmot_build_gcc_20070619_0910/include -lmpich -Wl,-rpath,/opt_X86_32/gm/2.0.18/lib -L/opt_X86_32/gm/2.0.18/lib/ -lgm
#
#$mpicc -o deadlock1_normal -m32 deadlock1.c -- OK
#
#$/volvox/HLRS/hlrs/hpchimml/marmot_build_gcc_20070619_0952/bin/marmotcc -o deadlock1_marmot -m32 deadlock1.c
#
#mpicc -o deadlock1_marmot -m32 deadlock1.c -L/schrotti/HLRS/hlrs/hpchimml/marmot_build_gcc_20070619_0952/lib -lmarmot-profile -lmarmot-core -L/opt_X86_32/mpi/mpich-1.2.6..14-Myrinet-gcc/lib -lpmpich -lmpich -lpmpich -L/opt_X86_32/gm/2.0.18/lib -lgm -lpthread -L/usr/lib -lstdc++ -I/schrotti/HLRS/hlrs/hpchimml/marmot_build_gcc_20070619_0952/include
#
#/usr/bin/ld: warning: i386:x86-64 architecture of input file `/schrotti/HLRS/hlrs/hpchimml/marmot_build_gcc_20070619_0952/lib/libmarmot-core.a(mpo_fortran_datatypehelpers.o)' is incompatible with i386 output -- OK
#
#$mpirun -np 2 -machinefile $PBS_NODEFILE ./deadlock1_normal
# I am rank 0 of 2 PEs
#  I am rank 1 of 2 PEs
#
#	OK
#
#
#$mpirun -np 3 -machinefile $PBS_NODEFILE ./deadlock1_marmot
# I am rank 0 of 2 PEs
#  I am rank 1 of 2 PEs
#  WARNING: all clients are pending! (Details see the LogFile)
#
#  OK
#
#
###############################################################################
#
#
#Intel 8.1
#mpich-1.2.6
#
#
#$mpicc -show deadlock1.c
#icc -DUSE_STDARG -DHAVE_STDLIB_H=1 -DHAVE_STRING_H=1 -DHAVE_UNISTD_H=1 -DHAVE_STDARG_H=1 -DUSE_STDARG=1 -DMALLOC_RET_VOID=1 -c deadlock1.c -I/opt_X86_32/mpi/mpich-1.2.6..14-Myrinet-Intel8.1/include
#icc -DUSE_STDARG -DHAVE_STDLIB_H=1 -DHAVE_STRING_H=1 -DHAVE_UNISTD_H=1 -DHAVE_STDARG_H=1 -DUSE_STDARG=1 -DMALLOC_RET_VOID=1 -Wl,-rpath -Wl,/opt_X86_32/mpi/mpich-1.2.6..14-Myrinet-Intel8.1/lib/shared -L/opt_X86_32/mpi/mpich-1.2.6..14-Myrinet-Intel8.1/lib/shared -L/opt_X86_32/mpi/mpich-1.2.6..14-Myrinet-Intel8.1/lib deadlock1.o -lmpich -Wl,-rpath,/opt_X86_32/gm/2.0.18/lib/ -L/opt_X86_32/gm/2.0.18/lib/ -lgm
#
#$/volvox/HLRS/hlrs/hpchimml/marmot_build_intel_20070618_1659/bin/marmotcc -show deadlock1.c
#
#mpicc -show deadlock1.c -L/schrotti/HLRS/hlrs/hpchimml/marmot_build_intel_20070618_1659/lib -lmarmot-profile -lmarmot-core -L/opt_X86_32/mpi/mpich-1.2.6..14-Myrinet-Intel8.1/lib -lpmpich -lmpich -lpmpich -L/opt_X86_32/gm/2.0.18/lib -lgm -lpthread -L/usr/lib -lstdc++ -I/schrotti/HLRS/hlrs/hpchimml/marmot_build_intel_20070618_1659/include
#
#icc -DUSE_STDARG -DHAVE_STDLIB_H=1 -DHAVE_STRING_H=1 -DHAVE_UNISTD_H=1 -DHAVE_STDARG_H=1 -DUSE_STDARG=1 -DMALLOC_RET_VOID=1 -c deadlock1.c -L/schrotti/HLRS/hlrs/hpchimml/marmot_build_intel_20070618_1659/lib -L/opt_X86_32/mpi/mpich-1.2.6..14-Myrinet-Intel8.1/lib -L/opt_X86_32/gm/2.0.18/lib -L/usr/lib -I/schrotti/HLRS/hlrs/hpchimml/marmot_build_intel_20070618_1659/include -I/opt_X86_32/mpi/mpich-1.2.6..14-Myrinet-Intel8.1/include
#icc -DUSE_STDARG -DHAVE_STDLIB_H=1 -DHAVE_STRING_H=1 -DHAVE_UNISTD_H=1 -DHAVE_STDARG_H=1 -DUSE_STDARG=1 -DMALLOC_RET_VOID=1 -Wl,-rpath -Wl,/opt_X86_32/mpi/mpich-1.2.6..14-Myrinet-Intel8.1/lib/shared -L/opt_X86_32/mpi/mpich-1.2.6..14-Myrinet-Intel8.1/lib/shared -L/opt_X86_32/mpi/mpich-1.2.6..14-Myrinet-Intel8.1/lib deadlock1.o -L/schrotti/HLRS/hlrs/hpchimml/marmot_build_intel_20070618_1659/lib -lmarmot-profile -lmarmot-core -L/opt_X86_32/mpi/mpich-1.2.6..14-Myrinet-Intel8.1/lib -lpmpich -lmpich -lpmpich -L/opt_X86_32/gm/2.0.18/lib -lgm -lpthread -L/usr/lib -lstdc++ -I/schrotti/HLRS/hlrs/hpchimml/marmot_build_intel_20070618_1659/include -lmpich -Wl,-rpath,/opt_X86_32/gm/2.0.18/lib/ -L/opt_X86_32/gm/2.0.18/lib/ -lgm
#
#mpicc -o deadlock1_normal deadlock1.c -- OK
#
#$/volvox/HLRS/hlrs/hpchimml/marmot_build_intel_20070618_1659/bin/marmotcc -o deadlock1_marmot deadlock1.c
#
#mpicc -o deadlock1_marmot deadlock1.c -L/schrotti/HLRS/hlrs/hpchimml/marmot_build_intel_20070618_1659/lib -lmarmot-profile -lmarmot-core -L/opt_X86_32/mpi/mpich-1.2.6..14-Myrinet-Intel8.1/lib -lpmpich -lmpich -lpmpich -L/opt_X86_32/gm/2.0.18/lib -lgm -lpthread -L/usr/lib -lstdc++ -I/schrotti/HLRS/hlrs/hpchimml/marmot_build_intel_20070618_1659/include -- OK
#
#$mpirun -np 2 -machinefile $PBS_NODEFILE ./deadlock1_normal
# I am rank 1 of 2 PEs
#  I am rank 0 of 2 PEs
#
# OK
#
#$mpirun -np 3 -machinefile $PBS_NODEFILE ./deadlock1_marmot
# I am rank 0 of 2 PEs
#  I am rank 1 of 2 PEs
#  WARNING: all clients are pending! (Details see the LogFile)
#
#  OK
#
###############################################################################
